/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

require([
    "aps/xhr",
    "dojo/promise/all",
    "aps/load",
    "app/viewUser",
    "app/common",
    "app/messages",
    "app/wizardData"
], function (
    xhr,
    all,
    load,
    viewUser,
    common,
    messages,
    wizardData
) {
    var account = aps.context.vars.user,
        tenant = aps.context.vars.tenant,
        userDefer = xhr.get("/aps/2/resources/" + account.aps.id + "/user"),
        profileDefer = xhr.get("/aps/2/resources/" + tenant.aps.id + "/profile");

    all({
        users: userDefer,
        profiles: profileDefer
    }).then(function (response) {
        var userQuota = response.profiles && response.profiles.length ? response.profiles[0].userQuota : common.USER_QUOTA.STRICT,
            user = response.users[0],
            result = viewUser.renderControls(account, user, true, userQuota, tenant);

        load(result).then(function () {
            messages.removeAll();
            var viewId = common.getRelatedViewId('view'),
                data = wizardData.getWizardData(viewId);
            if (data && data.message) {
                messages.displayMessage(data.message.text, data.message.type);
                wizardData.resetWizardData(viewId);
            }
        });
    }, messages.displayError);
});