/*
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

define([
    "dojo/_base/declare",
    "dojo/Deferred",
    "aps/xhr"
], function (
    declare,
    Deferred,
    xhr
) {
    return declare(null, {
        backupAccount: null,

        constructor: function (backupAccount) {
            this.backupAccount = backupAccount;
        },

        activate: function () {
            var self = this,
                deferred = new Deferred();
            aps.apsc.showPopup({
                viewId: "http://www.acronis.com/aps/cloud-backup-v1#nextcp-mycp-activate",
                params: {enduser: self.backupAccount},
                modal: true
            }).then(function (callback) {
                deferred.resolve(callback.btnType === "submit");
            }, deferred.reject);
            return deferred;
        },

        changePassword: function () {
            var self = this,
                deferred = new Deferred();
            aps.apsc.showPopup({
                viewId: "http://www.acronis.com/aps/cloud-backup-v1#nextcp-mycp-password",
                params: {enduser: self.backupAccount},
                modal: true
            }).then(function (callback) {
                deferred.resolve(callback.btnType === "submit");
            }, deferred.reject);
            return deferred;
        },

        loginToConsole: function () {
            var self = this,
                deferred = new Deferred();
            xhr.get("/aps/2/resources/" + self.backupAccount.aps.id + "/loginByToken").then(function (uri) {
                deferred.resolve(uri);
            }, deferred.reject);
            return deferred;
        }
    });
});
