/*
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

require([
    "aps/load"
], function (load) {

    var backupItems = [
        {
            "id": "datacenter",
            "title": _("Datacenters"),
            "click": 'aps.apsc.gotoView("pcp-menu--datacenter--list"); return false;'
        },
        {
            "id": "backup-profile",
            "title": _("Backup Profiles"),
            "click": 'aps.apsc.gotoView("pcp-menu--backup-profile--list"); return false;'
        }
    ];

    var templateToolsItem = function (image, title, items) {
        var templateItems = "";
        items.forEach(function (item) {
            templateItems += "" +
                "<li>" +
                "<a id=''" + item["id"] + "' onclick='" + item["click"] + "' href='javascript:void(0);'>" + _(item["title"]) + "</a>" +
                "</li>";
        });

        return "" +
            "<li>" +
            "<div class='tool-block'>" +
            "<span class='tool-icon'>" +
            "<img src='" + image + "'/>" +
            "</span>" +
            "<span class='tool-name'>" + _(title) + "</span>" +
            "<ul class='tool-info'>" + templateItems + "</ul>" +
            "</div>" +
            "</li>";
    };
    var widgets = ["aps/PageContainer", {id: "apsPageContainer"}, [
        ["aps/ToolsList", [
            ["aps/Output", {
                value: templateToolsItem("images/logo.png", _("Backup Configuration"), backupItems),
                escapeHTML: false
            }]
        ]]
    ]];
    load(widgets);
});
