import os
import sys
import struct
import socket

def getLanIp():
    endpoint_host = os.environ.get('ENDPOINT_HOST')
    if endpoint_host is not None:
        return endpoint_host
    output = os.popen("ip -f inet addr | awk '/inet /{print substr($2,0)}' | sed 's/\/[0-9]*//'")
    for line in output:
        cleaned_line = line.strip()
        if line is not None and _is_internal_network(cleaned_line):
            return cleaned_line
    return None

def checkRpcResponse(ret) :
    if ret['status'] != 0 :
        print "Error: {0}".format(ret['error_message'])
        sys.exit(-1)

def _is_internal_network(ip):
    f = struct.unpack('!I', socket.inet_pton(socket.AF_INET, ip))[0]
    private = (
        [ 3232235520, 4294901760 ], # 192.168.0.0, 255.255.0.0 http://tools.ietf.org/html/rfc1918
        [ 2886729728, 4293918720 ], # 172.16.0.0,  255.240.0.0 http://tools.ietf.org/html/rfc1918
        [ 167772160,  4278190080 ], # 10.0.0.0,    255.0.0.0   http://tools.ietf.org/html/rfc1918
    )
    for net in private:
        if (f & net[1] == net[0]):
            return True
    return False
