<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

require_once(__DIR__ . '/app/bootstrap.php');

/**
 * @type("http://acronis.com/aps/cloud-backup-v1/admin/4.0")
 * @implements("http://aps-standard.org/types/core/resource/1.0")
 */
class admin extends APSResource
{
    const LOG_CALLED_GET_PARTNER_CREDENTIALS = 'Get partner %s credentials was called.';

    /**
     * @link("http://acronis.com/aps/cloud-backup-v1/tenant/9.0")
     * @required
     */
    public $tenant;

    /**
     * @link("http://parallels.com/aps/types/pa/admin-user/1.0")
     * @required
     */
    public $staffMember;

    /** @type("integer") */
    public $mspAdminId;

    /** @type("integer") */
    public $status;

    /** @type("integer") */
    public $backupNotification;

    /** @type("integer") */
    public $quotaNotification;

    /**
     * @verb(POST)
     * @path("/onAdminChanged")
     *
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     * @deprecated 
     */
    public function onAdminChanged($event)
    {
    }

    /**
     * @return PartnerCredentials
     * @throws Exception
     */
    public function getPartnerCredentials()
    {
        Log::getInstance()->event(self::LOG_CALLED_GET_PARTNER_CREDENTIALS);
        $message = sprintf(self::EXCEPTION_METHOD_IS_NOT_APPLICABLE_MESSAGE, __METHOD__);
        Log::getInstance()->warning($message);
        throw new Exception($message);     
    }
}
