<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

interface Model_ManagerFactoryInterface
{
    /**
     * @param Service_MspApiClient_ApiInterface $mspApi
     * @return Model_UserManagerInterface
     */
    public function getUserManager(Service_MspApiClient_ApiInterface $mspApi);

    /**
     * @param \APS\ControllerProxy $apsc
     * @param \APS\ResourceProxy | \APS\ResourceBase $global
     * @param \APS\ResourceProxy | \APS\ResourceBase $datacenter
     * @param Service_MspApiClient_ApiInterface $mspApi
     * @param Service_OpenApi_ApiInterface $openApi
     * @return Model_MspGroup_OpenApiRetrieverInterface
     */
    public function getOpenApiRetrieverForDatacenter(
        $apsc,
        $global,
        $datacenter,
        Service_MspApiClient_ApiInterface $mspApi,
        Service_OpenApi_ApiInterface $openApi
    );

    /**
     * @param Service_MspApiClient_ApiInterface $mspApi
     * @param Service_APSApi_ApiInterface $apsApi
     * @return Model_MspGroupManager
     */
    public function getMspGroupManager(Service_MspApiClient_ApiInterface $mspApi, Service_APSApi_ApiInterface $apsApi);

    /**
     * @param Service_MspApiClient_ApiInterface $mspApi
     * @return Model_TenantManager
     */
    public function getTenantManager(Service_MspApiClient_ApiInterface $mspApi);

    /**
     * @param usersCCPv2 $backupAccount
     * @return Model_UserScreenNotificationManagerInterface
     */
    public function getUserScreenNotificationManager($backupAccount);

    /**
     * @param Service_PbaApi_ApiInterface $pbaApi
     * @return Model_OSA_SubscriptionParametersManagerInterface
     */
    public function getSubscriptionParametersManager(Service_PbaApi_ApiInterface $pbaApi);

    /**
     * @param Service_PbaApi_ApiInterface $pbaApi
     * @return Model_OSA_AccountAttributesManagerInterface
     */
    public function getAccountAttributesManager(Service_PbaApi_ApiInterface $pbaApi);

    /**
     * @param Service_OpenApi_ApiInterface $openApi
     * @param Service_PbaApi_ApiInterface $pbaApi
     * @return Model_MinimalCommitmentDiscountManager
     */
    public function getMinimalCommitmentDiscountManager(
        Service_OpenApi_ApiInterface $openApi,
        Service_PbaApi_ApiInterface $pbaApi
    );

    /**
     * @param Service_MspApiClient_ApiInterface $mspApi
     * @param $datacenter
     * @return Model_UsageReportManager
     */
    public function getUsageReportManager(Service_MspApiClient_ApiInterface $mspApi, $datacenter);
}
