<?php
/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

interface Model_MspGroupManagerInterface
{
    /**
     * @param tenant $tenant
     * @param int $parentGroupId
     * @param int $datacenterId
     * @return int
     * @throws Exception
     */
    public function createGroupForReseller($tenant, $parentGroupId, $datacenterId = null);

    /**
     * @param int $groupId
     * @param tenant $tenant
     * @return int
     * @throws Exception
     */
    public function updateGroupForReseller($groupId, $tenant);

    /**
     * @param tenant $tenant
     * @param int $parentGroupId
     * @param int $groupKind
     * @param string $language
     * @return int
     * @throws Exception
     * @throws Service_BaseClient_HTTPException
     */
    public function createGroupForCustomer(
        $tenant,
        $parentGroupId,
        $groupKind = Service_MspApiClient_Request_Struct_CreateGroup::EUC_GROUP_KIND_ID,
        $language = null
    );

    /**
     * @param tenant $tenant
     * @param $tenantStrategy
     */
    public function updatePrivilegesForCustomers($tenant, $tenantStrategy);

    /**
     * @param int $groupId
     * @param tenant $tenant
     * @return int
     * @throws Exception
     * @throws Service_BaseClient_HTTPException
     */
    public function updateGroupForCustomer($groupId, $tenant);

    /**
     * @param int $groupId
     * @param tenant $tenant
     * @param int $newParentGroupId
     * @return int
     * @throws Exception
     * @throws Service_BaseClient_HTTPException
     */
    public function migrateGroupForCustomer($groupId, $tenant, $newParentGroupId);

    /**
     * @param string $companyName
     * @param Service_MspApiClient_Response_Struct_GroupInfo $groupInfo
     * @return string
     */
    public function fetchNameForGroup($companyName, Service_MspApiClient_Response_Struct_GroupInfo $groupInfo);
}
