<?php
/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

/**
 * Interface Model_Resource_TenantInterface
 */
interface Model_Resource_TenantInterface extends Model_Resource_ResourceInterface, Model_Resource_SuspendableInterface
{
    /* ======= RESOURCE EVENTS ======= */

    public function onTenantAvailable($event);

    public function onSubscriptionChange($event);

    public function onAccountChange($event);

    public function onUserChanged($event);

    /* ======= RESOURCE OPERATIONS ======= */

    public function createAdministrator($parameters, $datacenterId = '');

    public function getAdministrators();

    public function getAdministrator($adminId, $datacenterId = '');

    public function updateAdministrator($adminId, $parameters, $datacenterId = '');

    public function deleteAdministrator($adminId, $datacenterId = '');

    public function getAdministratorConsole($adminId, $datacenterId = '');

    public function resendAdministratorLink($adminId, $datacenterId = '');

    public function enableAdministrator($adminId, $datacenterId = '');

    public function disableAdministrator($adminId, $datacenterId = '');

    public function adminUrlRedirect();

    public function updateUsageAndLimits();

    public function getDatacenter();

    public function getDatacenters();

    public function getStorages();

    public function getServicePlans();

    public function getServicePlan($planId);

    public function setStorageForPlan($planId, $parameters);

    public function unsetStorageForPlan($planId);

    public function loginExists($login, $datacenterId = '');

    public function getQuotasStatistics();

    public function getUserGuideUrl();

    public function resolveDatacenterId();

    public function resolveBackupStorageId();
}
