<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Model_ScreenNotification_Struct_LocalizedMessageConverter implements Model_ScreenNotification_Struct_LocalizedMessageConverterInterface
{
    const FIELD_MESSAGE = "message";
    const FIELD_KEYS = "keys";

    const PREFIX_GET = 'get';
    const PREFIX_SET = 'set';

    /**
     * @param array $array
     * @param $object
     * @param $field
     */
    private static function _fromArrayToObject(array &$array, $object, $field)
    {
        if (isset($array[$field]))
        {
            $value = $array[$field];
            $methodReflection = new ReflectionMethod($object, self::PREFIX_SET . ucfirst($field));
            $methodReflection->invoke($object, $value);
        }
    }

    /**
     * @param array $array
     * @param $object
     * @param $field
     */
    private static function _toArrayFromObject(array &$array, $object, $field)
    {
        $methodReflection = new ReflectionMethod($object, self::PREFIX_GET . ucfirst($field));
        $value = $methodReflection->invoke($object);
        if (isset($value))
        {
            $array[$field] = $value;
        }
    }

    /**
     * @param array $array
     * @return Model_ScreenNotification_Struct_LocalizedMessageInterface
     */
    public static function fromArray(array $array)
    {
        $object = new Model_ScreenNotification_Struct_LocalizedMessage();

        self::_fromArrayToObject($array, $object, self::FIELD_MESSAGE);
        self::_fromArrayToObject($array, $object, self::FIELD_KEYS);

        return $object;
    }

    /**
     * @param Model_ScreenNotification_Struct_LocalizedMessageInterface $object
     * @return array
     */
    public static function toArray($object)
    {
        $array = array();

        self::_toArrayFromObject($array, $object, self::FIELD_MESSAGE);
        self::_toArrayFromObject($array, $object, self::FIELD_KEYS);

        return $array;
    }

} 