<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

/**
 * @link https://doc.apsstandard.org/2.2/spec/ui/integration-ccp/notifications/
 */
class Model_ScreenNotification_Struct_Message implements Model_ScreenNotification_Struct_MessageInterface
{
    const TYPE_ACTIVITY = "activity";
    const TYPE_WARNING = "warning";

    const STATUS_IN_PROGRESS = "inProgress";
    const STATUS_ERROR = "error";
    const STATUS_READY = "ready";
    const STATUS_EXISTING = "existing";
    const STATUS_UPCOMING = "upcoming";

    /**
     * @var string
     * @readonly
     */
    private $_id;

    /**
     * @var string
     */
    private $_type;

    /**
     * @var string
     */
    private $_status;

    /**
     * @var Model_ScreenNotification_Struct_LocalizedMessage
     * @required
     */
    private $_message;

    /**
     * @var Model_ScreenNotification_Struct_LocalizedMessage
     */
    private $_details;

    /**
     * @var Model_ScreenNotification_Struct_LocalizedMessage
     */
    private $_fullDetails;

    /**
     * @var string
     */
    private $_link;

    /**
     * @var string
     */
    private $_linkMore;

    /**
     * @var Model_ScreenNotification_Struct_LocalizedMessage
     */
    private $_linkMoreText;

    /**
     * @var string
     * @required
     */
    private $_packageId;

    /**
     * @var boolean
     */
    private $_updated;

    /**
     * @var boolean
     */
    private $_resolved;

    /**
     * @var string
     * @dateTime
     */
    private $_created;

    /**
     * @var string
     * @dateTime
     */
    private $_modified;

    /**
     * @var string
     */
    private $_accountId;

    /**
     * @var string
     */
    private $_userId;

    /**
     * @var string
     */
    private $_context;

    /**
     * @var string
     */
    private $_initiatorId;

    /**
     * @var string
     */
    private $_initiator;

    /**
     * @var string
     */
    private $_service;

    /**
     * @var string
     */
    private $_required;

    /**
     * @var string
     */
    private $_parentId;

    /**
     * @var string
     */
    private $_ipAddress;

    /**
     * @param string $accountId
     */
    public function setAccountId($accountId)
    {
        $this->_accountId = $accountId;
    }

    /**
     * @return string
     */
    public function getAccountId()
    {
        return $this->_accountId;
    }

    /**
     * @param string $context
     */
    public function setContext($context)
    {
        $this->_context = $context;
    }

    /**
     * @return string
     */
    public function getContext()
    {
        return $this->_context;
    }

    /**
     * @param string $created
     */
    public function setCreated($created)
    {
        $this->_created = $created;
    }

    /**
     * @return string
     */
    public function getCreated()
    {
        return $this->_created;
    }

    /**
     * @param Model_ScreenNotification_Struct_LocalizedMessageInterface $details
     */
    public function setDetails(Model_ScreenNotification_Struct_LocalizedMessageInterface $details = null)
    {
        $this->_details = $details;
    }

    /**
     * @return Model_ScreenNotification_Struct_LocalizedMessageInterface
     */
    public function getDetails()
    {
        return $this->_details;
    }

    /**
     * @param Model_ScreenNotification_Struct_LocalizedMessageInterface $fullDetails
     */
    public function setFullDetails(Model_ScreenNotification_Struct_LocalizedMessageInterface $fullDetails = null)
    {
        $this->_fullDetails = $fullDetails;
    }

    /**
     * @return Model_ScreenNotification_Struct_LocalizedMessageInterface
     */
    public function getFullDetails()
    {
        return $this->_fullDetails;
    }

    /**
     * @param string $id
     */
    public function setId($id)
    {
        $this->_id = $id;
    }

    /**
     * @return string
     */
    public function getId()
    {
        return $this->_id;
    }

    /**
     * @param string $link
     */
    public function setLink($link)
    {
        $this->_link = $link;
    }

    /**
     * @return string
     */
    public function getLink()
    {
        return $this->_link;
    }

    /**
     * @param string $linkMore
     */
    public function setLinkMore($linkMore)
    {
        $this->_linkMore = $linkMore;
    }

    /**
     * @return string
     */
    public function getLinkMore()
    {
        return $this->_linkMore;
    }

    /**
     * @param Model_ScreenNotification_Struct_LocalizedMessageInterface $linkMoreText
     */
    public function setLinkMoreText(Model_ScreenNotification_Struct_LocalizedMessageInterface $linkMoreText = null)
    {
        $this->_linkMoreText = $linkMoreText;
    }

    /**
     * @return Model_ScreenNotification_Struct_LocalizedMessageInterface
     */
    public function getLinkMoreText()
    {
        return $this->_linkMoreText;
    }

    /**
     * @param Model_ScreenNotification_Struct_LocalizedMessageInterface $message
     */
    public function setMessage(Model_ScreenNotification_Struct_LocalizedMessageInterface $message = null)
    {
        $this->_message = $message;
    }

    /**
     * @return Model_ScreenNotification_Struct_LocalizedMessageInterface
     */
    public function getMessage()
    {
        return $this->_message;
    }

    /**
     * @param string $modified
     */
    public function setModified($modified)
    {
        $this->_modified = $modified;
    }

    /**
     * @return string
     */
    public function getModified()
    {
        return $this->_modified;
    }

    /**
     * @param string $packageId
     */
    public function setPackageId($packageId)
    {
        $this->_packageId = $packageId;
    }

    /**
     * @return string
     */
    public function getPackageId()
    {
        return $this->_packageId;
    }

    /**
     * @param boolean $resolved
     */
    public function setResolved($resolved)
    {
        $this->_resolved = $resolved;
    }

    /**
     * @return boolean
     */
    public function getResolved()
    {
        return $this->_resolved;
    }

    /**
     * @param string $status
     */
    public function setStatus($status)
    {
        $this->_status = $status;
    }

    /**
     * @return string
     */
    public function getStatus()
    {
        return $this->_status;
    }

    /**
     * @param string $type
     */
    public function setType($type)
    {
        $this->_type = $type;
    }

    /**
     * @return string
     */
    public function getType()
    {
        return $this->_type;
    }

    /**
     * @param boolean $updated
     */
    public function setUpdated($updated)
    {
        $this->_updated = $updated;
    }

    /**
     * @return boolean
     */
    public function getUpdated()
    {
        return $this->_updated;
    }

    /**
     * @param string $userId
     */
    public function setUserId($userId)
    {
        $this->_userId = $userId;
    }

    /**
     * @return string
     */
    public function getUserId()
    {
        return $this->_userId;
    }

    /**
     * @return string
     */
    public function getInitiatorId()
    {
        return $this->_initiatorId;
    }

    /**
     * @param string $initiatorId
     */
    public function setInitiatorId($initiatorId)
    {
        $this->_initiatorId = $initiatorId;
    }

    /**
     * @return string
     */
    public function getInitiator()
    {
        return $this->_initiator;
    }

    /**
     * @param string $initiator
     */
    public function setInitiator($initiator)
    {
        $this->_initiator = $initiator;
    }

    /**
     * @return string
     */
    public function getService()
    {
        return $this->_service;
    }

    /**
     * @param string $service
     */
    public function setService($service)
    {
        $this->_service = $service;
    }

    /**
     * @return string
     */
    public function getRequired()
    {
        return $this->_required;
    }

    /**
     * @param string $required
     */
    public function setRequired($required)
    {
        $this->_required = $required;
    }

    /**
     * @return string
     */
    public function getParentId()
    {
        return $this->_parentId;
    }

    /**
     * @param string $parentId
     */
    public function setParentId($parentId)
    {
        $this->_parentId = $parentId;
    }

    /**
     * @return string
     */
    public function getIpAddress()
    {
        return $this->_ipAddress;
    }

    /**
     * @param string $ipAddress
     */
    public function setIpAddress($ipAddress)
    {
        $this->_ipAddress = $ipAddress;
    }
}