<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

interface Model_UserManagerInterface
{
    /**
     * @param $login
     * @param string $password
     * @return
     * @internal param string $email
     */
    public function activateUser($login, $password);

    /**
     * @param string $email
     * @param string $password
     * @throws Exception
     */
    public function resetUserPassword($email, $password);

    /**
     * @param int $userId
     * @param int $version
     * @return int
     */
    public function enableUser($userId, $version);

    /**
     * @param int $userId
     * @param int $version
     * @return int
     */
    public function disableUser($userId, $version);

    /**
     * @param int $groupId
     * @return array
     */
    public function getBackItems($groupId);

    /**
     * @param string $email
     * @param int $groupId
     * @return NULL|Service_MspApiClient_Response_Struct_UserInfo
     */
    public function getUserByEmail($email, $groupId);

    /**
     * @param string $companyName
     * @return NULL|Service_MspApiClient_Response_Struct_GroupInfo
     */
    public function getGroupByName($companyName);

    /**
     * add administrator account to baas with data from PA staff member
     *
     * @param int $mspGroupId
     * @param int $subscriptionId
     * @param Service_MspApiClient_Request_Struct_AdministratorInfo $userInfo
     * @throws Exception
     */
    public function provisionAdministratorAccount($mspGroupId, $subscriptionId, Service_MspApiClient_Request_Struct_AdministratorInfo $userInfo);
}
