<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_AmsApiClient_Request_GetLinksList extends Service_BaseClient_Request_Base
{
    const REQUEST_URL = '/ams/links/list';

    const EXCEPT_LINKS_LIST_NOT_EXIST = 'Links list does not exist: %s';
    const RESPONSE_200 = 200;

    public function __construct()
    {
        $this->_method = self::METHOD_GET;
        $this->_resource = self::REQUEST_URL;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @throws Exception
     * @return Service_AmsApiClient_Response_GetLinksList
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        if (self::RESPONSE_200 != $httpCode)
        {
            throw new Exception(sprintf(self::EXCEPT_LINKS_LIST_NOT_EXIST, $this->_resource));
        }
        return new Service_AmsApiClient_Response_GetLinksList($responseBody);
    }
} 