<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_AmsApiClient_Response_BackupPlans extends Service_BaseClient_Response_Base
{
    const FIELD_LAST_BACKUP = 'lastBackup';
    const FIELD_NEXT_BACKUP = 'nextBackup';
    const FIELD_DATA = 'data';
    const FIELD_ID = 'id';
    const FIELD_ONLINE = 'online';
    const FIELD_OS = 'os';
    const FIELD_STATUS = 'status';
    const FIELD_TITLE = 'title';
    const FIELD_TYPE = 'type';

    const TYPE_GROUP = 'group';

    /**
     * @param array $responseData
     * @return  array of Service_AmsApiClient_Response_Struct_BackupRecordInterface
     * @throws Exception
     */
    protected function _init(array $responseData)
    {
        $resources = array();
        if (!isset($responseData[self::FIELD_DATA])) {
            return $resources;
        }

        foreach ($responseData[self::FIELD_DATA] as $item) {
            if (!isset($item[self::FIELD_TYPE])
                || strtolower($item[self::FIELD_TYPE]) === strtolower(self::TYPE_GROUP)
            ) {
                continue;
            }
            $newItem = new Service_AmsApiClient_Response_Struct_BackupRecord();
            $newItem->setId($item[self::FIELD_ID]);
            if (isset($item[self::FIELD_LAST_BACKUP])) {
                $newItem->setLastBackup($item[self::FIELD_LAST_BACKUP]);
            }
            if (isset($item[self::FIELD_NEXT_BACKUP])) {
                $newItem->setNextBackup($item[self::FIELD_NEXT_BACKUP]);
            }
            $newItem->setOs($this->_getProperty(self::FIELD_OS, $item, false));
            $newItem->setStatus($this->_getProperty(self::FIELD_STATUS, $item, false));
            $newItem->setTitle($this->_getProperty(self::FIELD_TITLE, $item, false));
            $newItem->setType($this->_getProperty(self::FIELD_TYPE, $item, false));
            $resources[] = $newItem;
        }
        return $resources;
    }
}
