<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_AmsApiClient_Response_Connection extends Service_BaseClient_Response_Base
{
    const FIELD_HOST_NAME = 'host_name';
    const FIELD_USER_NAME = 'user_name';

    const FIELD_HOST_NAME_M1 = 'hostName';
    const FIELD_USER_NAME_M1 = 'userName';

    /** @var Service_AmsApiClient_Response_Struct_ConnectionInterface */
    private $_connectionInfo;

    /**
     * @param string|null $responseBody
     * @param Service_AmsApiClient_Response_Struct_ConnectionInterface $connectionInfo
     */
    public function __construct($responseBody = NULL,
                                Service_AmsApiClient_Response_Struct_ConnectionInterface $connectionInfo = NULL)
    {
        $this->_connectionInfo = is_null($connectionInfo)
            ? new Service_AmsApiClient_Response_Struct_Connection()
            : $connectionInfo;
        parent::__construct($responseBody);
    }

    /**
     * @param array $responseData
     * @return Service_AmsApiClient_Response_Struct_ConnectionInterface
     */
    protected function _init(array $responseData)
    {
        $this->_connectionInfo->setHostName(isset($responseData[self::FIELD_HOST_NAME])
            ? $responseData[self::FIELD_HOST_NAME]
            : $responseData[self::FIELD_HOST_NAME_M1]);
        $this->_connectionInfo->setUserName(isset($responseData[self::FIELD_USER_NAME])
            ? $responseData[self::FIELD_USER_NAME]
            : $responseData[self::FIELD_USER_NAME_M1]);
        return $this->_connectionInfo;
    }
} 
