<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_AmsApiClient_Response_GetLinksList extends Service_BaseClient_Response_Base
{
    const PROPERTY_AGENTS = 'agents';
    const PROPERTY_AGENTS_URL = 'url';
    const PROPERTY_AGENTS_SYSTEM = 'system';
    const PROPERTY_AGENTS_LANGUAGE = 'language';
    const PROPERTY_AGENTS_TYPE = 'type';
    const PROPERTY_AGENTS_ARCHITECTURE = 'architecture';
    const PROPERTY_AGENTS_TITLE = 'title';
    const PROPERTY_AGENTS_SIZE = 'size';
    const PROPERTY_AGENTS_PERSONIFIED = 'personified';
    const PROPERTY_AGENTS_WEB = 'web';

    /**
     * @param array $responseData
     * @return Service_AmsApiClient_Response_Struct_LinksList
     */
    protected function _init(array $responseData)
    {
        $agents = array();
        $agentsData = $this->_getProperty(self::PROPERTY_AGENTS, $responseData);
        foreach($agentsData as $agentData)
        {
            $agent = new Service_AmsApiClient_Response_Struct_LinksListAgentsItem();

            $agent->setUrl($this->_getProperty(self::PROPERTY_AGENTS_URL, $agentData));
            $agent->setSystem($this->_getProperty(self::PROPERTY_AGENTS_SYSTEM, $agentData));
            $agent->setLanguage($this->_getProperty(self::PROPERTY_AGENTS_LANGUAGE, $agentData));
            $agent->setType($this->_getProperty(self::PROPERTY_AGENTS_TYPE, $agentData));
            $agent->setArchitecture($this->_getProperty(self::PROPERTY_AGENTS_ARCHITECTURE, $agentData));

            $agent->setTitle($this->_getProperty(self::PROPERTY_AGENTS_TITLE, $agentData, false));
            $agent->setSize($this->_getProperty(self::PROPERTY_AGENTS_SIZE, $agentData, false));
            $agent->setPersonified($this->_getProperty(self::PROPERTY_AGENTS_PERSONIFIED, $agentData, false));
            $agent->setWeb($this->_getProperty(self::PROPERTY_AGENTS_WEB, $agentData, false));

            $agents[] = $agent;
        }

        $links = new Service_AmsApiClient_Response_Struct_LinksList();
        $links->setAgents($agents);
        return $links;
    }
}
