<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

abstract class Service_BaseClient_Request_Struct_Updatable
    implements Service_BaseClient_Request_Struct_IArrayRepresentation
{
    /** @var array */
    private $_updateMap = array();

    /**
     * @param array $updateMap
     */
    public function __construct(array $updateMap = array())
    {
        $this->_updateMap = $updateMap;
    }

    /**
     * @return bool
     */
    public function isExistsUpdateFields()
    {
        foreach ($this->_updateMap as $isFieldUpdated)
        {
            if ($isFieldUpdated)
            {
                return true;
            }
        }
        return false;
    }

    /**
     * @param string $fieldName
     * @return bool
     */
    protected function _isFieldChanged($fieldName)
    {
        if (isset($this->_updateMap[$fieldName]) && $this->_updateMap[$fieldName])
        {
            return true;
        }
        return false;
    }

    /**
     * @param string $fieldName
     * @param bool $isUpdated
     */
    protected function _markFieldAsUpdated($fieldName, $isUpdated=true)
    {
        $this->_updateMap[$fieldName] = $isUpdated;
    }
}
