<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_BaseClient_TransportStrategy_Json
    implements Service_BaseClient_TransportStrategy_ITransportStrategy
{
    const CONTENT_TYPE_APPLICATION_JSON = 'Content-Type: application/json; charset=utf-8';

    /**
     * @param CurlInterface $curlHandle
     * @param string $authHeaders
     * @param string|array $data
     */
    public function prepare(CurlInterface $curlHandle, $data, $authHeaders = NULL)
    {
        $curlHandle->setOption(CURLOPT_POSTFIELDS, $data);

        //hardcoded +header Authorization
        $headers = array(self::CONTENT_TYPE_APPLICATION_JSON);
        if (is_array($authHeaders))
        {
            $headers = array_merge($headers, $authHeaders);
        }

        $curlHandle->setOption(CURLOPT_HTTPHEADER, $headers);
    }
}
