<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_BaseClient_TransportStrategy_Simple
    implements Service_BaseClient_TransportStrategy_ITransportStrategy
{
    const CONTENT_TYPE_APPLICATION_JSON = 'Content-Type: application/json; charset=utf-8';
    const CONTENT_LENGTH_ZERO = 'Content-Length: 0';

    /**
     * @param CurlInterface $curlHandle
     * @param string|array $data
     * @param string $authHeaders
     */
    public function prepare(CurlInterface $curlHandle, $data, $authHeaders = NULL)
    {
        //hardcoded +header Authorization
        $headers = array(self::CONTENT_TYPE_APPLICATION_JSON, self::CONTENT_LENGTH_ZERO);
        if (is_array($authHeaders))
        {
            $headers = array_merge($headers, $authHeaders);
        }
        $curlHandle->setOption(CURLOPT_HTTPHEADER, $headers);
    }
}
