<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_Accounts extends Service_BaseClient_Request_Base
{
    const REQUEST_URL_FORMAT = '/accounts/?login=%s';

    const HEADER_XML_HTTP_REQUEST = 'X-Requested-With: XMLHttpRequest';

    /**
     * @param string $login
     */
    public function __construct($login)
    {
        $this->_resource = sprintf(self::REQUEST_URL_FORMAT, urlencode($login));
        $this->_method = self::METHOD_GET;
        $this->_headers = array_merge(
            $this->_headers,
            [self::HEADER_XML_HTTP_REQUEST]
        );
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_Accounts
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_MspApiClient_Response_Accounts($responseBody);
    }
}