<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_BackupConsole extends Service_BaseClient_Request_Base
{
    const REQUEST_URL_FORMAT = '/groups/%s/backupconsole?app=apc&language=%s';

    const DEFAULT_LANGUAGE = 'en';

    /**
     * @param int $groupId
     * @param string $language
     */
    public function __construct($groupId, $language = NULL)
    {
        $this->_resource = sprintf(self::REQUEST_URL_FORMAT, $groupId,
            is_null($language) ? self::DEFAULT_LANGUAGE : $language);
        $this->_method = self::METHOD_GET;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_BackupConsole
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_MspApiClient_Response_BackupConsole($responseBody);
    }
}
