<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_DeleteGroup extends Service_BaseClient_Request_Base
{
    const REQUEST_URL_FORMAT = '/groups/%s/?version=%s';

    /**
     * @param int $groupId
     * @param int $version
     */
    public function __construct($groupId, $version)
    {
        $this->_resource = sprintf(self::REQUEST_URL_FORMAT, $groupId, $version);
        $this->_method = self::METHOD_DELETE;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_Version
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_MspApiClient_Response_Version($responseBody);
    }
}