<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_MailUpdate extends Service_BaseClient_Request_Base
{
    const REQUEST_URL_PATH = '/actions/mail/emailupdate/?';
    const PARAMETER_LOGIN = 'login';
    const PARAMETER_EMAIL = 'email';

    /**
     * Service_MspApiClient_Request_MailUpdate constructor.
     * @param string $login
     * @param string $email
     */
    public function __construct($login, $email)
    {
        $this->_method = self::METHOD_GET;
        $this->_resource = self::REQUEST_URL_PATH . http_build_query(array(
            self::PARAMETER_LOGIN => $login,
            self::PARAMETER_EMAIL => $email
        ));
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_MailActivate
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_MspApiClient_Response_MailUpdate($responseBody);
    }
}