<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_Struct_AdministratorUpdate extends Service_MspApiClient_Request_Struct_AdministratorInfo
{
    const FIELD_STATUS = 'status';

    const STATUS_ENABLE = 1;
    const STATUS_DISABLE = 0;

    /** @var int */
    private $_status;

    /**
     * @return array
     */
    public function toArray()
    {
        $result = array();
        if ($this->_isFieldChanged(self::FIELD_TYPE))
        {
            $result[self::FIELD_TYPE] = $this->getType();
        }
        if ($this->_isFieldChanged(self::FIELD_EMAIL))
        {
            $result[self::FIELD_EMAIL] = $this->getEmail();
        }
        if ($this->_isFieldChanged(self::FIELD_FIRSTNAME))
        {
            $result[self::FIELD_FIRSTNAME] = $this->getFirstName();
        }
        if ($this->_isFieldChanged(self::FIELD_LASTNAME))
        {
            $result[self::FIELD_LASTNAME] = $this->getLastName();
        }
        if ($this->_isFieldChanged(self::FIELD_STATUS))
        {
            $result[self::FIELD_STATUS] = $this->getStatus();
        }
        if ($this->_isFieldChanged(self::FIELD_NOTIFICATIONS_BACKUP))
        {
            $result[self::FIELD_NOTIFICATIONS_BACKUP] = $this->getNotificationsBackup();
        }
        if ($this->_isFieldChanged(self::FIELD_NOTIFICATIONS_MANAGEMENT))
        {
            $result[self::FIELD_NOTIFICATIONS_MANAGEMENT] = $this->getNotificationsManagement();
        }
        return $result;
    }
    
    /**
     * @param int $status
     */
    public function setStatus($status)
    {
        $this->_markFieldAsUpdated(self::FIELD_STATUS);
        $this->_status = $status;
    }

    /**
     * @return int
     */
    public function getStatus()
    {
        return $this->_status;
    }
}
