<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_Struct_GroupPricing
    extends Service_BaseClient_Request_Struct_Updatable
{
    const PRODUCTION_MODE = 1;
    const TRIAL_MODE = 3;
    const ENABLED_OFF = 0;
    const FIELD_ENABLED = 'enabled';
    const FIELD_MODE = "mode";

    /** @var int */
    private $_mode = self::TRIAL_MODE;
    private $_enabled;

    /**
     * @return array
     */
    public function toArray()
    {
        $result = array();
        if ($this->_isFieldChanged(self::FIELD_MODE)) {
            $result[self::FIELD_MODE] = $this->getMode();
        }
        if ($this->_isFieldChanged(self::FIELD_ENABLED)) {
            $result[self::FIELD_ENABLED] = $this->getEnabled();
        }
        return $result;
    }

    /**
     * @param int $mode
     */
    public function setMode($mode)
    {
        $this->_markFieldAsUpdated(self::FIELD_MODE);
        $this->_mode = $mode;
    }

    /**
     * @return int
     */
    public function getMode()
    {
        return $this->_mode;
    }

    /**
     * @return int
     */
    public function getEnabled()
    {
        return $this->_enabled;
    }

    /**
     * @param int $enabled
     */
    public function setEnabled($enabled)
    {
        $this->_markFieldAsUpdated(self::FIELD_ENABLED);
        $this->_enabled = $enabled;
    }
}
