<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_MspApiClient_Request_Struct_UpdateGroupPrivileges
    extends Service_MspApiClient_Request_Struct_GroupPrivileges
{
    /**
     * @return array
     */
    public function toArray()
    {
        $result = array();

        if ($this->_isFieldChanged(self::FIELD_WORKSTATION_COUNT)) {
            $result[self::FIELD_WORKSTATION_COUNT] = $this->getWorkstationCount();
            $result[self::FIELD_QUOTA_WORKSTATIONS_HARD] = $this->getWorkstationCount();
        }

        if ($this->_isFieldChanged(self::FIELD_MOBILE_COUNT)) {
            $count = $this->getMobileCount();
            if (!is_null($count)) {
                $result[self::FIELD_MOBILE_COUNT] = $count;
                $result[self::FIELD_QUOTA_MOBILES_HARD] = $count;
            }
        }

        if ($this->_isFieldChanged(self::FIELD_MAILBOX_COUNT)) {
            $count = $this->getMailboxCount();
            if (!is_null($count)) {
                $result[self::FIELD_MAILBOX_COUNT] = $count;
                $result[self::FIELD_QUOTA_MAILBOX_HARD] = $count;
            }
        }

        if ($this->_isFieldChanged(self::FIELD_WEBSITE_COUNT)) {
            $count = $this->getWebsiteCount();
            if (!is_null($count)) {
                $result[self::FIELD_WEBSITE_COUNT] = $count;
                $result[self::FIELD_QUOTA_WEBSITES_HARD] = $count;
            }
        }

        if ($this->_isFieldChanged(self::FIELD_QUOTA_MAILBOX_INSTANCE_STORAGE)) {
            $count = $this->getMailboxInstanceStorageSize();
            if (!is_null($count)) {
                $result[self::FIELD_QUOTA_MAILBOX_INSTANCE_STORAGE] = $count;
            }
        }

        if ($this->_isFieldChanged(self::FIELD_SERVER_COUNT)) {
            $result[self::FIELD_SERVER_COUNT] = $this->getServerCount();
            $result[self::FIELD_QUOTA_SERVERS_HARD] = $this->getServerCount();
        }

        if ($this->_isFieldChanged(self::FIELD_VM_COUNT)) {
            $result[self::FIELD_VM_COUNT] = $this->getVmCount();
            $result[self::FIELD_QUOTA_VMS_HARD] = $this->getVmCount();
        }

        if ($this->_isFieldChanged(self::FIELD_STORAGE_SIZE)) {
            $result[self::FIELD_STORAGE_SIZE] = $this->getStorageSize();
            $result[self::FIELD_QUOTA_STORAGE_HARD] = $this->getStorageSize();
        }

        if ($this->_isFieldChanged(self::FIELD_LOCAL_BACKUP)) {
            $result[self::FIELD_LOCAL_BACKUP] = $this->getLocalBackup()->toArray();
        }

        if ($this->_isFieldChanged(self::FIELD_CLOUD_TO_CLOUD_BACKUP)) {
            $result[self::FIELD_CLOUD_TO_CLOUD_BACKUP] = $this->getCloudToCloudBackup();
        }

        return $result;
    }
}
