<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_MspApiClient_Request_Struct_UpdateUserPrivileges extends Service_MspApiClient_Request_Struct_UserPrivileges
{
    /**
     * @return array
     */
    public function toArray()
    {
        $result = array();
        if ($this->_isFieldChanged(self::FIELD_QUOTA_SERVERS_HARD)) {
            $result[self::FIELD_QUOTA_SERVERS_HARD] = $this->getServerCount();
            $result[self::FIELD_SERVER_COUNT] = $this->getServerCount();
        }
        if ($this->_isFieldChanged(self::FIELD_QUOTA_STORAGE_HARD)) {
            $result[self::FIELD_QUOTA_STORAGE_HARD] = $this->getStorageSize();
            $result[self::FIELD_STORAGE_SIZE] = $this->getStorageSize();
        }
        if ($this->_isFieldChanged(self::FIELD_QUOTA_VMS_HARD)) {
            $result[self::FIELD_QUOTA_VMS_HARD] = $this->getVmCount();
            $result[self::FIELD_VM_COUNT] = $this->getVmCount();
        }
        if ($this->_isFieldChanged(self::FIELD_QUOTA_WORKSTATIONS_HARD)) {
            $result[self::FIELD_QUOTA_WORKSTATIONS_HARD] = $this->getWorkstationCount();
            $result[self::FIELD_WORKSTATION_COUNT] = $this->getWorkstationCount();
        }
        if ($this->_isFieldChanged(self::FIELD_QUOTA_MOBILES_HARD)) {
            $count = $this->getMobileCount();
            if (!is_null($count)) {
                $result[self::FIELD_QUOTA_MOBILES_HARD] = $count;
                $result[self::FIELD_MOBILE_COUNT] = $count;
            }
        }
        if ($this->_isFieldChanged(self::FIELD_QUOTA_MAILBOX_HARD)) {
            $count = $this->getMailboxCount();
            if (!is_null($count)) {
                $result[self::FIELD_QUOTA_MAILBOX_HARD] = $count;
                $result[self::FIELD_MAILBOX_COUNT] = $count;
            }
        }
        if ($this->_isFieldChanged(self::FIELD_QUOTA_WEBSITES_HARD)) {
            $count = $this->getWebsiteCount();
            if (!is_null($count)) {
                $result[self::FIELD_QUOTA_WEBSITES_HARD] = $count;
                $result[self::FIELD_WEBSITE_COUNT] = $count;
            }
        }
        return $result;
    }
}