<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_UpdateGroup extends Service_BaseClient_Request_Json
{
    const REQUEST_URL_FORMAT = '/groups/%d/?version=%s';

    /**
     * @param Service_MspApiClient_Request_Struct_UpdateGroupInterface $requestObject
     * @param int $groupId
     * @param int $version
     */
    public function __construct(Service_MspApiClient_Request_Struct_UpdateGroupInterface $requestObject, $groupId,
                                $version)
    {
        $this->_requestObject = $requestObject;
        $this->_resource = sprintf(self::REQUEST_URL_FORMAT, $groupId, $version);
        $this->_method = self::METHOD_PUT;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_Version
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_MspApiClient_Response_Version($responseBody);
    }
}