<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_UpdateUser extends Service_BaseClient_Request_Json
{
    const REQUEST_URL_FORMAT = '/users/%s/?version=%s';

    /**
     * @param  Service_BaseClient_Request_Struct_IArrayRepresentation $requestObject
     * @param int $userId
     * @param int $version
     */
    public function __construct(Service_BaseClient_Request_Struct_IArrayRepresentation $requestObject, $userId, $version)
    {
        $this->_requestObject = $requestObject;
        $this->_resource = sprintf(self::REQUEST_URL_FORMAT, $userId, $version);
        $this->_method = self::METHOD_PUT;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_Version
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_MspApiClient_Response_Version($responseBody);
    }
}