<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Response_GetAdministratorById extends Service_BaseClient_Response_Base
{
    const PROPERTY_ID = 'id';
    const PROPERTY_ACCESS_TYPE = 'access_type';
    const PROPERTY_EMAIL = 'email';
    const PROPERTY_FIRST_NAME = 'firstname';
    const PROPERTY_GROUP = 'group';
    const PROPERTY_LAST_NAME = 'lastname';
    const PROPERTY_LOGIN = 'login';
    const PROPERTY_NOTIFICATIONS_BACKUP = 'notifications_backup';
    const PROPERTY_NOTIFICATIONS_MANAGEMENT = 'notifications_management';
    const PROPERTY_STATUS= 'status';
    const PROPERTY_VERSION = 'version';

    /**
     * @param array $responseData
     * @return Service_MspApiClient_Response_Struct_AdministratorInfo
     */
    protected function _init(array $responseData)
    {
        $adminInfo = new Service_MspApiClient_Response_Struct_AdministratorInfo();
        $adminInfo->setId($this->_getProperty(self::PROPERTY_ID, $responseData));
        $adminInfo->setAccessType($this->_getProperty(self::PROPERTY_ACCESS_TYPE, $responseData));
        $adminInfo->setEmail($this->_getProperty(self::PROPERTY_EMAIL, $responseData));
        $adminInfo->setFirstName($this->_getProperty(self::PROPERTY_FIRST_NAME, $responseData));
        $adminInfo->setLastName($this->_getProperty(self::PROPERTY_LAST_NAME, $responseData));
        $adminInfo->setGroup($this->_getProperty(self::PROPERTY_GROUP, $responseData));
        $adminInfo->setLogin($this->_getProperty(self::PROPERTY_LOGIN, $responseData));
        $adminInfo->setNotificationsBackup($this->_getProperty(self::PROPERTY_NOTIFICATIONS_BACKUP, $responseData));
        $adminInfo->setNotificationsManagement($this->_getProperty(self::PROPERTY_NOTIFICATIONS_MANAGEMENT, $responseData));
        $adminInfo->setStatus($this->_getProperty(self::PROPERTY_STATUS, $responseData));
        $adminInfo->setVersion($this->_getProperty(self::PROPERTY_VERSION, $responseData));

        return $adminInfo;
    }
}
