<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Response_GetAdministrators extends Service_BaseClient_Response_Base
{
    const PROPERTY_ITEMS = 'items';
    const PROPERTY_EMAIL = 'email';
    const PROPERTY_FIRSTNAME = 'firstname';
    const PROPERTY_LASTNAME = 'lastname';
    const PROPERTY_STATUS = 'status';
    const PROPERTY_ID = 'id';
    const PROPERTY_LOGIN = 'login';
    const PROPERTY_ROLES = 'roles';
    const PROPERTY_USER_ID = 'user_id';
    const PROPERTY_ACCESS_TYPE = 'access_type';
    const PROPERTY_VERSION = 'version';

    /** @var Service_MspApiClient_Response_Struct_FactoryInterface */
    private $_factory;

    /**
     * @param string|null $responseBody
     * @param Service_MspApiClient_Response_Struct_FactoryInterface $factory
     */
    public function __construct($responseBody = NULL, Service_MspApiClient_Response_Struct_FactoryInterface $factory = NULL)
    {
        $this->_factory = is_null($factory) ? new Service_MspApiClient_Response_Struct_Factory() : $factory;
        parent::__construct($responseBody);
    }

    /**
     * @param array $responseData
     * @return array of Service_MspApiClient_Response_Struct_AdministratorItem
     */
    protected function _init(array $responseData)
    {
        $admins = array();
        $items = $this->_getProperty(self::PROPERTY_ITEMS, $responseData);
        foreach ($items as $itemData)
        {
            $adminItem = $this->_factory->getAdministratorItem();
            $adminItem->setEmail($this->_getProperty(self::PROPERTY_EMAIL, $itemData));
            $adminItem->setFirstName($this->_getProperty(self::PROPERTY_FIRSTNAME, $itemData));
            $adminItem->setLastName($this->_getProperty(self::PROPERTY_LASTNAME, $itemData));
            $adminItem->setStatus($this->_getProperty(self::PROPERTY_STATUS, $itemData));
            $adminItem->setId($this->_getProperty(self::PROPERTY_ID, $itemData));
            $adminItem->setUserId($this->_getProperty(self::PROPERTY_USER_ID, $itemData));
            $adminItem->setLogin($this->_getProperty(self::PROPERTY_LOGIN, $itemData));
            $adminItem->setAccessType($this->_getProperty(self::PROPERTY_ACCESS_TYPE, $itemData));
            $adminItem->setRoles($this->_getProperty(self::PROPERTY_ROLES, $itemData));
            $adminItem->setVersion($this->_getProperty(self::PROPERTY_VERSION, $itemData));

            $admins[] = $adminItem;
        }
        return $admins;
    }
}