<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Response_GetGroups extends Service_BaseClient_Response_Base
{
    const PROPERTY_ITEMS = 'items';
    const PROPERTY_GRADE = 'grade';
    const PROPERTY_KIND = 'kind';
    const PROPERTY_ID = 'id';
    const PROPERTY_STATUS = 'status';
    const PROPERTY_VERSION = 'version';
    const PROPERTY_HAS_CHILDREN = 'has_children';
    const PROPERTY_CAPABILITIES = 'capabilities';
    const PROPERTY_NAME = 'name';
    const PROPERTY_INTERNAL_TAG = 'internal_tag';

    /**
     * @param array $responseData
     * @return array of Service_MspApiClient_Response_Struct_UserItem
     */
    protected function _init(array $responseData)
    {
        $groups = array();
        foreach ($responseData[self::PROPERTY_ITEMS] as $params)
        {
            $userItem = new Service_MspApiClient_Response_Struct_GroupItem();
            $userItem->setGrade($params[self::PROPERTY_GRADE]);
            $userItem->setKind($params[self::PROPERTY_KIND]);
            $userItem->setId($params[self::PROPERTY_ID]);
            $userItem->setStatus($params[self::PROPERTY_STATUS]);
            $userItem->setVersion($params[self::PROPERTY_VERSION]);
            $userItem->setHasChildren($params[self::PROPERTY_HAS_CHILDREN]);
            $userItem->setCapabilities($params[self::PROPERTY_CAPABILITIES]);
            $userItem->setName($params[self::PROPERTY_NAME]);
            $userItem->setInternalTag($params[self::PROPERTY_INTERNAL_TAG]);
            $groups[] = $userItem;
        }
        return $groups;
    }
}
