<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Response_Struct_Storage implements Service_MspApiClient_Response_Struct_StorageInterface
{
    /** @var  int */
    private $_id;
    /** @var  int */
    private $_version;
    /** @var  string */
    private $_name;
    /** @var  string */
    private $_uid;
    /** @var  int */
    private $_kind;
    /** @var  int */
    private $_owner;
    /** @var  string */
    private $_spaceUsage;
    /** @var  int */
    private $_inherited;
    /** @var  int */
    private $_active;
    /** @var  string */
    private $_contentUrl;

    /**
     * @param int $id
     * @param int $version
     * @param string $name
     * @param string $uid
     * @param int $kind
     * @param int $owner
     * @param string $spaceUsage
     * @param int $inherited
     * @param int $active
     * @param string $contentUrl
     */
    public function __construct($id, $version, $name, $uid, $kind, $owner, $spaceUsage, $inherited, $active, $contentUrl)
    {
        $this->_id = $id;
        $this->_version = $version;
        $this->_name = $name;
        $this->_uid = $uid;
        $this->_kind = $kind;
        $this->_owner = $owner;
        $this->_spaceUsage = $spaceUsage;
        $this->_inherited = $inherited;
        $this->_active =$active;
        $this->_contentUrl = $contentUrl;
    }

    /**
     * @return int
     */
    public function getActive()
    {
        return $this->_active;
    }

    /**
     * @return string
     */
    public function getContentUrl()
    {
        return $this->_contentUrl;
    }

    /**
     * @return int
     */
    public function getId()
    {
        return $this->_id;
    }

    /**
     * @return int
     */
    public function getInherited()
    {
        return $this->_inherited;
    }

    /**
     * @return int
     */
    public function getKind()
    {
        return $this->_kind;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->_name;
    }

    /**
     * @return int
     */
    public function getOwner()
    {
        return $this->_owner;
    }

    /**
     * @return string
     */
    public function getSpaceUsage()
    {
        return $this->_spaceUsage;
    }

    /**
     * @return string
     */
    public function getUid()
    {
        return $this->_uid;
    }

    /**
     * @return int
     */
    public function getVersion()
    {
        return $this->_version;
    }
}