<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Response_Struct_UserInfo
{
    const STATUS_DISABLED = 0;
    const STATUS_ENABLED = 1;
    const STATUS_INACTIVE = -1;

    /** @var  int */
    private $id;
    /** @var  int */
    private $group;
    /** @var  string */
    private $address1;
    /** @var  string */
    private $address2;
    /** @var  string */
    private $city;
    /** @var  string */
    private $country;
    /** @var  string */
    private $email;
    /** @var  string */
    private $firstName;
    /** @var  string */
    private $lastName;
    /** @var  int */
    private $notifications;
    /** @var  int */
    private $notificationsBackup;
    /** @var  int */
    private $notificationsManagement;
    /** @var  string */
    private $phone;
    /** @var Service_MspApiClient_Request_Struct_UserPrivileges */
    private $privileges;
    /** @var  string */
    private $state;
    /** @var  int */
    private $status;
    /** @var  Service_MspApiClient_Response_Struct_UserUsage */
    private $usage;
    /** @var  int */
    private $version;
    /** @var  string */
    private $zipCode;
    /** @var  string */
    private $login;
    /** @var  int */
    private $privileged;

    public function __construct()
    {
        $this->privileges = new Service_MspApiClient_Response_Struct_UserPrivileges();
        $this->usage = new Service_MspApiClient_Response_Struct_UserUsage();
    }

    /**
     * @param int $group
     */
    public function setGroup($group)
    {
        $this->group = $group;
    }

    /**
     * @return int
     */
    public function getGroup()
    {
        return $this->group;
    }

    /**
     * @param int $notificationsBackup
     */
    public function setNotificationsBackup($notificationsBackup)
    {
        $this->notificationsBackup = $notificationsBackup;
    }

    /**
     * @return int
     */
    public function getNotificationsBackup()
    {
        return $this->notificationsBackup;
    }

    /**
     * @param int $notificationsManagement
     */
    public function setNotificationsManagement($notificationsManagement)
    {
        $this->notificationsManagement = $notificationsManagement;
    }

    /**
     * @return int
     */
    public function getNotificationsManagement()
    {
        return $this->notificationsManagement;
    }

    /**
     * @param string $address1
     */
    public function setAddress1($address1)
    {
        $this->address1 = $address1;
    }

    /**
     * @return string
     */
    public function getAddress1()
    {
        return $this->address1;
    }

    /**
     * @param string $address2
     */
    public function setAddress2($address2)
    {
        $this->address2 = $address2;
    }

    /**
     * @return string
     */
    public function getAddress2()
    {
        return $this->address2;
    }

    /**
     * @param string $login
     */
    public function setLogin($login)
    {
        $this->login = $login;
    }

    /**
     * @return string
     */
    public function getLogin()
    {
        return $this->login;
    }

    /**
     * @param string $city
     */
    public function setCity($city)
    {
        $this->city = $city;
    }

    /**
     * @return string
     */
    public function getCity()
    {
        return $this->city;
    }

    /**
     * @param string $country
     */
    public function setCountry($country)
    {
        $this->country = $country;
    }

    /**
     * @return string
     */
    public function getCountry()
    {
        return $this->country;
    }

    /**
     * @param string $email
     */
    public function setEmail($email)
    {
        $this->email = $email;
    }

    /**
     * @return string
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * @param string $firstName
     */
    public function setFirstName($firstName)
    {
        $this->firstName = $firstName;
    }

    /**
     * @return string
     */
    public function getFirstName()
    {
        return $this->firstName;
    }

    /**
     * @param string $lastName
     */
    public function setLastName($lastName)
    {
        $this->lastName = $lastName;
    }

    /**
     * @return string
     */
    public function getLastName()
    {
        return $this->lastName;
    }

    /**
     * @param int $notifications
     */
    public function setNotifications($notifications)
    {
        $this->notifications = $notifications;
    }

    /**
     * @return int
     */
    public function getNotifications()
    {
        return $this->notifications;
    }

    /**
     * @param string $phone
     */
    public function setPhone($phone)
    {
        $this->phone = $phone;
    }

    /**
     * @return string
     */
    public function getPhone()
    {
        return $this->phone;
    }

    /**
     * @param Service_MspApiClient_Request_Struct_UserPrivileges $privileges
     */
    public function setPrivileges($privileges)
    {
        $this->privileges = $privileges;
    }

    /**
     * @return Service_MspApiClient_Request_Struct_UserPrivileges
     */
    public function getPrivileges()
    {
        if (!$this->privileges)
        {
            $this->privileges = new Service_MspApiClient_Request_Struct_UserPrivileges();            
        }

        return $this->privileges;
    }

    /**
     * @param string $state
     */
    public function setState($state)
    {
        $this->state = $state;
    }

    /**
     * @return string
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * @param string $zipCode
     */
    public function setZipCode($zipCode)
    {
        $this->zipCode = $zipCode;
    }

    /**
     * @return string
     */
    public function getZipCode()
    {
        return $this->zipCode;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $status
     */
    public function setStatus($status)
    {
        $this->status = $status;
    }

    /**
     * @return int
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * @param mixed $usage
     */
    public function setUsage($usage)
    {
        $this->usage = $usage;
    }

    /**
     * @return Service_MspApiClient_Response_Struct_UserUsage
     */
    public function getUsage()
    {
        return $this->usage;
    }

    /**
     * @param int $version
     */
    public function setVersion($version)
    {
        $this->version = $version;
    }

    /**
     * @return int
     */
    public function getVersion()
    {
        return $this->version;
    }

    /**
     * @return int
     */
    public function getPrivileged()
    {
        return $this->privileged;
    }

    /**
     * @param int $privileged
     */
    public function setPrivileged($privileged)
    {
        $this->privileged = $privileged;
    }
}