<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Response_Struct_UserItem
{
    /** @var  string */
    private $_email;
    /** @var  string */
    private $_login;
    /** @var  string */
    private $_firstName;
    /** @var  string */
    private $_lastName;
    /** @var  int */
    private $_status;
    /** @var  int */
    private $_privileged;
    /** @var  int */
    private $_id;
    /** @var  Service_MspApiClient_Response_Struct_UserUsage */
    private $_usage;
    /** @var Service_MspApiClient_Response_Struct_UserPrivileges */
    private $_privileges;

    public function __construct()
    {
        $this->_privileges = new Service_MspApiClient_Response_Struct_UserPrivileges();
        $this->_usage = new Service_MspApiClient_Response_Struct_UserUsage();
    }

    /**
     * @return Service_MspApiClient_Response_Struct_UserPrivileges
     */
    public function getPrivileges()
    {
        return $this->_privileges;
    }

    /**
     * @param Service_MspApiClient_Response_Struct_UserPrivileges $privileges
     */
    public function setPrivileges($privileges)
    {
        $this->_privileges = $privileges;
    }

    /**
     * @return Service_MspApiClient_Response_Struct_UserUsage
     */
    public function getUsage()
    {
        return $this->_usage;
    }

    /**
     * @param Service_MspApiClient_Response_Struct_UserUsage $usage
     */
    public function setUsage($usage)
    {
        $this->_usage = $usage;
    }

    /**
     * @param string $email
     */
    public function setEmail($email)
    {
        $this->_email = $email;
    }

    /**
     * @param string $login
     */
    public function setLogin($login)
    {
        $this->_login = $login;
    }

    /**
     * @return string
     */
    public function getLogin()
    {
        return $this->_login;
    }

    /**
     * @param string $firstName
     */
    public function setFirstName($firstName)
    {
        $this->_firstName = $firstName;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->_id = $id;
    }

    /**
     * @param int $privileged
     */
    public function setPrivileged($privileged)
    {
        $this->_privileged = $privileged;
    }

    /**
     * @return int
     */
    public function getPrivileged()
    {
        return $this->_privileged;
    }

    /**
     * @param string $lastName
     */
    public function setLastName($lastName)
    {
        $this->_lastName = $lastName;
    }

    /**
     * @param int $status
     */
    public function setStatus($status)
    {
        $this->_status = $status;
    }

    /**
     * @return string
     */
    public function getEmail()
    {
        return $this->_email;
    }

    /**
     * @return string
     */
    public function getFirstName()
    {
        return $this->_firstName;
    }

    /**
     * @return int
     */
    public function getId()
    {
        return $this->_id;
    }

    /**
     * @return string
     */
    public function getLastName()
    {
        return $this->_lastName;
    }

    /**
     * @return int
     */
    public function getStatus()
    {
        return $this->_status;
    }
}