<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_OpenApi_Response_AccountInfo implements Service_OpenApi_Response_AccountInfoInterface
{
    /** @var  string */
    private $_companyName;
    /** @var  int */
    private $_accountId;
    /** @var  int */
    private $_accountType;
    /** @var  int */
    private $_parentAccountId;
    /** @var  string */
    private $_phone;
    /** @var  Service_OpenApi_Response_AccountInfo_Address */
    private $_address;
    /** @var  Service_OpenApi_Response_AccountInfo_Contact */
    private $_contact;

    /**
     * @param string $companyName
     * @param string $accountId
     * @param string $accountType
     * @param string $parentAccountId
     * @param string $phone
     * @param Service_OpenApi_Response_AccountInfo_Address $address
     * @param Service_OpenApi_Response_AccountInfo_Contact $contact
     */
    public function __construct($companyName, $accountId, $accountType, $parentAccountId, $phone,
                                Service_OpenApi_Response_AccountInfo_Address $address,
                                Service_OpenApi_Response_AccountInfo_Contact $contact)
    {
        $this->_companyName = $companyName;
        $this->_accountId = $accountId;
        $this->_accountType = $accountType;
        $this->_parentAccountId = $parentAccountId;
        $this->_phone = $phone;
        $this->_address = $address;
        $this->_contact = $contact;
    }

    /**
     * @return int
     */
    public function getAccountId()
    {
        return $this->_accountId;
    }

    /**
     * @return int
     */
    public function getAccountType()
    {
        return $this->_accountType;
    }

    /**
     * @return Service_OpenApi_Response_AccountInfo_Address
     */
    public function getAddress()
    {
        return $this->_address;
    }

    /**
     * @return string
     */
    public function getCompanyName()
    {
        return $this->_companyName;
    }

    /**
     * @return Service_OpenApi_Response_AccountInfo_Contact
     */
    public function getContact()
    {
        return $this->_contact;
    }

    /**
     * @return int
     */
    public function getParentAccountId()
    {
        return $this->_parentAccountId;
    }

    /**
     * @return string
     */
    public function getPhone()
    {
        return $this->_phone;
    }
} 