<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_OpenApi_Response_SubscriptionInfo implements Service_OpenApi_Response_SubscriptionInfoInterface
{
    /** @var  int */
    private $_subscriptionId;
    /** @var  string */
    private $_name;
    /** @var  int */
    private $_serviceTemplateId;
    /** @var  int */
    private $_serviceTemplateVersion;
    /** @var  int */
    private $_ownerId;
    /** @var  boolean */
    private $_isActive;
    /** @var  array */
    private $_resourceTypes;

    /**
     * @param int $subscriptionId
     * @param string $name
     * @param int $serviceTemplateId
     * @param int $serviceTemplateVersion
     * @param int $ownerId
     * @param boolean $isActive
     * @param array $resourceTypes
     */
    function __construct(
        $subscriptionId,
        $name,
        $serviceTemplateId,
        $serviceTemplateVersion,
        $ownerId,
        $isActive,
        array $resourceTypes = array()
    )
    {
        $this->_subscriptionId = $subscriptionId;
        $this->_name = $name;
        $this->_serviceTemplateId = $serviceTemplateId;
        $this->_serviceTemplateVersion = $serviceTemplateVersion;
        $this->_ownerId = $ownerId;
        $this->_isActive = $isActive;
        $this->_resourceTypes = $resourceTypes;
    }

    /**
     * @return boolean
     */
    public function getIsActive()
    {
        return $this->_isActive;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->_name;
    }

    /**
     * @return int
     */
    public function getOwnerId()
    {
        return $this->_ownerId;
    }

    /**
     * @return int
     */
    public function getServiceTemplateId()
    {
        return $this->_serviceTemplateId;
    }

    /**
     * @return int
     */
    public function getServiceTemplateVersion()
    {
        return $this->_serviceTemplateVersion;
    }

    /**
     * @return int
     */
    public function getSubscriptionId()
    {
        return $this->_subscriptionId;
    }

    /**
     * @return array
     */
    public function getResourceTypes()
    {
        return $this->_resourceTypes;
    }
}