<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_OpenApi_Validator_Base implements Service_OpenApi_Validator_ItemInterface
{
    /** @var  Service_OpenApi_Validator_Base */
    private $_successorHandler;

    /**
     * @param Service_OpenApi_Validator_ItemInterface $successorHandler
     */
    function __construct(Service_OpenApi_Validator_ItemInterface $successorHandler = NULL)
    {
        $this->_successorHandler = $successorHandler;
    }

    /**
     * @param mixed $xmlRpcDecodedResponse
     * @param Service_OpenApi_Response_RawInterface $response
     * @throws Service_OpenApi_Validator_BaseException
     * @return bool
     */
    public function handleResponse($xmlRpcDecodedResponse, Service_OpenApi_Response_RawInterface $response = NULL)
    {
        if (is_null($this->_successorHandler))
        {
            return true;
        }
        return $this->_successorHandler->handleResponse($xmlRpcDecodedResponse, $response);
    }
} 
