<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_OpenApi_Validator_InvalidCode extends Service_OpenApi_Validator_Base
{
    const INVALID_HTTP_RESPONSE = 'Invalid HTTP response code (%s)';

    /**
     * @param mixed $xmlRpcDecodedResponse
     * @param Service_OpenApi_Response_RawInterface $response
     * @throws Service_OpenApi_Validator_BaseException
     * @return bool
     */
    public function handleResponse($xmlRpcDecodedResponse, Service_OpenApi_Response_RawInterface $response = NULL)
    {
        if (!$response->isSuccess())
        {
            throw new Service_OpenApi_Validator_BaseException(sprintf(
                self::INVALID_HTTP_RESPONSE,
                $response->getHttpCode()
            ));
        }
        return parent::handleResponse($xmlRpcDecodedResponse);
    }
} 
