<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_OpenApi_XmlRpc
{
    const ENCODING = "utf8";

    /**
     * @param string $method
     * @param array $params
     * @param array $outputOptions
     * @return string
     */
    public function encodeRequest($method, $params, array $outputOptions = array())
    {
        return xmlrpc_encode_request($method, $params, $outputOptions);
    }

    /**
     * @param string $xml
     * @param string $encoding
     * @return array|NULL
     */
    public function decode($xml, $encoding = self::ENCODING)
    {
        return xmlrpc_decode($xml, $encoding);
    }

    /**
     * @param array $arg
     * @return bool
     */
    public function isFault(array $arg)
    {
        return xmlrpc_is_fault($arg);
    }
} 
