<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Exception extends Exception
{
    const CAN_NOT_RECEIVE_PARAMETER_CODE = 1;
    const CAN_NOT_RECEIVE_LIST_OF_ATTRIBUTES_CODE = 2;
    const CAN_NOT_GET_AVAILABLE_PLAN_LIST_CODE = 3;
    const CAN_NOT_GET_PLAN_CODE = 4;
    const CAN_NOT_GET_PLAN_CATEGORIES_CODE = 5;
    const CAN_NOT_GET_SUBSCRIPTION_DETAILS_CODE = 6;
    const CAN_NOT_GET_SUBSCRIPTION_RESOURCES_LIST_CODE = 7;
    const CAN_NOT_PLACE_RESOURCE_UPGRADE_ORDER_CODE = 8;
    const CAN_NOT_GET_ORDER_CODE = 9;
    const CAN_NOT_GET_ACCOUNT_LIST_CODE = 10;
    const CAN_NOT_GET_VENDOR_CURRENCY_CODE = 11;
    const CAN_NOT_GET_PLAN_PERIOD_LIST_CODE = 12;
    const CAN_NOT_PLACE_ORDER_AND_AUTHORIZE_CODE = 13;
    const CAN_NOT_UPDATE_OBJ_ATTR_LIST_CODE = 14;
    const CAN_NOT_GET_RESOURCE_CODE = 15;
    const CAN_NOT_GET_INCLUDED_RESOURCES_CODE = 16;
    const CAN_NOT_GET_SUBSCRIPTION_SALES_ORDERS_CODE = 17;
    const CAN_NOT_GET_ORDER_DETAILS_CODE = 18;
    const CAN_NOT_CREATE_MANUAL_ORDER_CODE = 19;
    const CAN_NOT_PLACE_PLAN_PERIOD_SWITCH_ORDER_CODE = 20;
    const CAN_NOT_GET_SUBSCRIPTION_DETAILS_EX_CODE = 21;
    const CAN_NOT_GET_PLAN_RATE_LIST_CODE = 22;
    const CAN_NOT_GET_SUBSCRIPTION_AVAILABLE_PLAN_LIST_CODE = 23;
    const CAN_NOT_GET_ACCOUNT_CODE = 24;
    const CAN_NOT_GET_ORDER_PROVISIONING_ITEMS_CODE = 25;
    const CAN_NOT_CHANGE_ORDER_STATUS_CODE = 26;
    const CAN_NOT_GET_DISCOUNTS_LIST = 27;
    const CAN_NOT_GET_DISCOUNT_BY_ID = 28;
    const CAN_NOT_ADD_ACCOUNT_DISCOUNT_CODE = 29;
    const CAN_NOT_MOVE_TO_ARCHIVE_ACCOUNT_DISCOUNT_CODE = 30;
    const CAN_NOT_UPDATE_SUBSCRIPTION_PARAMETER_BY_ID_CODE = 31;
    const CAN_NOT_CHANGE_EXPIRATION_CODE = 32;
    const CAN_NOT_START_SUBSCRIPTION_CODE = 33;
    const CAN_NOT_EXTEND_TRIAL_PERIOD_CODE = 34;
    const CAN_NOT_UPDATE_SUBSCRIPTION_WITH_INCORRECT_STATUS_CODE = 35;
    const CAN_NOT_UPDATE_SUBSCRIPTION_STATUS_CODE = 36;
    const CAN_NOT_GET_PLAN_RATE_LIST_FOR_PERIOD_CODE = 37;
    const CAN_NOT_GET_PLAN_RATES_FOR_PLAN_CODE = 38;
    const CAN_NOT_GET_PLAN_DETAILS_CODE = 39;
    const CAN_NOT_START_SUBSCRIPTION_BY_ID = 40;
    const CAN_NOT_SPLIT_DELIVER_LINES_FOR_VENDOR_BY_DATE_CODE = 41;
    const CAN_NOT_MERGE_DELIVER_LINES_FOR_PERIOD_BY_VENDOR_CODE = 42;
    const CAN_NOT_GET_DELIVER_LINES_FOR_PERIOD_BY_VENDOR_LIST_CODE = 43;
    const CAN_NOT_GET_PLAN_HISTORY_LIST_CODE = 44;
    const CAN_NOT_GET_PLAN_FROM_ARCHIVE_CODE = 45;
    const CAN_NOT_GET_PUBLICATION_STATUS_FOR_PLAN_CODE = 46;
    const CAN_NOT_UPDATE_PUBLICATION_STATUS_FOR_PLAN_CODE = 47;
    const CAN_NOT_GET_DISCOUNTED_RESOURCES_BY_DISCOUNT_CODE = 48;
    const CAN_NOT_GET_DISCOUNTED_PLANS_BY_DISCOUNT_CODE = 49;
    const CAN_NOT_GET_ORDER_DETAIL_CODE = 50;
    const CAN_NOT_GET_PLAN_PERIOD_CODE = 51;
    const CAN_NOT_PLACE_SUBSCRIPTION_CANCELLATION_ORDER_CODE = 52;
    const CAN_NOT_GET_AND_VALIDATE_PLAN_PARAMETERS_CODE = 53;
    const CAN_NOT_GET_ATTRIBUTES_TYPE_LIST_CODE = 54;
    const CAN_NOT_GET_PLAN_RATE_LIST_FULL_CODE = 55;
    const CAN_NOT_GET_CUSTOMER_SUBSCRIPTION_LIST_CODE = 56;
    const CAN_NOT_GET_SUBSCRIPTION_LIST_BY_ORDER_CODE = 57;

    const CAN_NOT_RECEIVE_PARAMETER_MESSAGE = 'Can\'t receive value for parameter "%s" from subscription "%s".';
    const CAN_NOT_RECEIVE_LIST_OF_ATTRIBUTES_MESSAGE = 'Can\'t receive the list of attributes for object "%s" type "%s".';
    const CAN_NOT_GET_AVAILABLE_PLAN_LIST_MESSAGE = 'Can\'t get the list of available plans by account id "%s".';
    const CAN_NOT_GET_PLAN_MESSAGE = 'Can\'t get the plan by id "%s".';
    const CAN_NOT_GET_PLAN_CATEGORIES_MESSAGE = 'Can\'t get plan categories by account ID "%s".';
    const CAN_NOT_GET_SUBSCRIPTION_DETAILS_MESSAGE = 'Can\'t get subscription details by ID "%s".';
    const CAN_NOT_GET_SUBSCRIPTION_RESOURCES_LIST_MESSAGE = 'Can\'t get subscription resources list by ID "%s".';
    const CAN_NOT_PLACE_RESOURCE_UPGRADE_ORDER_MESSAGE = 'Can\'t place order to upgrade the resources in the subscription with ID "%s".';
    const CAN_NOT_GET_ORDER_MESSAGE = 'Can\'t get order by ID "%s".';
    const CAN_NOT_GET_ACCOUNT_LIST_BY_CUSTOM_ATTRIBUTE_MESSAGE = 'Can\'t get account list by attribute %s with value "%s".';
    const CAN_NOT_GET_VENDOR_CURRENCY_MESSAGE = 'Can\'t get vendor currency with vendor id  "%s".';
    const CAN_NOT_GET_PLAN_PERIOD_LIST_MESSAGE = 'Can\'t get plan period list by service plan with id "%s",';
    const CAN_NOT_PLACE_ORDER_AND_AUTHORIZE_MESSAGE = 'Can\'t place order and authorize.';
    const CAN_NOT_UPDATE_OBJ_ATTR_LIST_MESSAGE = 'Can\'t update object attribute list.';
    const CAN_NOT_UPDATE_SUBSCRIPTION_STATUS_MESSAGE = 'Can\'t update status for subscription "%s".';
    const CAN_NOT_EXTEND_TRIAL_PERIOD_MESSAGE = 'Can\'t extend trial period of subscription.';
    const CAN_NOT_GET_RESOURCE_MESSAGE = 'Can\'t get resource with id "%s".';
    const CAN_NOT_GET_INCLUDED_RESOURCES_MESSAGE = 'Can\'t get included resources of resource with id "%s".';
    const CAN_NOT_GET_SUBSCRIPTION_SALES_ORDERS_MESSAGE = 'Can\'t get sales orders of subscription with id "%s".';
    const CAN_NOT_GET_ORDER_DETAILS_MESSAGE = 'Can\'t get order details for order with id "%s".';
    const CAN_NOT_CREATE_MANUAL_ORDER_MESSAGE = 'Can\'t create manual order.';
    const CAN_NOT_PLACE_PLAN_PERIOD_SWITCH_ORDER_MESSAGE = 'Can\'t place plan period switch order for subscription "%s".';
    const CAN_NOT_GET_SUBSCRIPTION_DETAILS_EX_MESSAGE = 'Can\'t get subscription details by ID "%s".';
    const CAN_NOT_GET_PLAN_RATE_LIST_MESSAGE = 'Can\'t get plan rate list by service plan with id "%s".';
    const CAN_NOT_GET_SUBSCRIPTION_AVAILABLE_PLAN_LIST_MESSAGE = 'Can\'t get the list of available plans for subscription "%s".';
    const CAN_NOT_GET_ACCOUNT_MESSAGE = 'Can\'t get account by ID "%s".';
    const CAN_NOT_GET_ORDER_PROVISIONING_ITEMS_MESSAGE = 'Can\'t get order provisioning items for order with id "%s".';
    const CAN_NOT_CHANGE_ORDER_STATUS_MESSAGE = 'Can\'t change status for order "%s".';
    const CAN_NOT_CHANGE_EXPIRATION_MESSAGE = 'Can\'t change expiration for subscription "%s".';
    const CAN_NOT_GET_DISCOUNTS_LIST_MESSAGE = 'Can\'t get discounts.';
    const CAN_NOT_GET_DISCOUNT_BY_ID_MESSAGE = 'Can\'t get discount with ID "%s".';
    const CAN_NOT_ADD_ACCOUNT_DISCOUNT_MESSAGE = 'Can\'t add discount "%s" for account "%s".';
    const CAN_NOT_MOVE_TO_ARCHIVE_ACCOUNT_DISCOUNT_MESSAGE = 'Can\'t move to archive discount "%s" for account "%s".';
    const CAN_NOT_START_SUBSCRIPTION_MESSAGE = 'Can\'t start subscription "%s".';
    const CAN_NOT_UPDATE_SUBSCRIPTION_PARAMETER_BY_ID_MESSAGE = 'Can\'t update parameter of subscription with ID "%s".';
    const CAN_NOT_UPDATE_SUBSCRIPTION_WITH_INCORRECT_STATUS_MESSAGE = 'Can\'t update expiration date of subscription with such status.';
    const CAN_NOT_GET_PLAN_RATE_LIST_FOR_PERIOD_MESSAGE = 'Can\'t get plan rate list for period with id "%s".';
    const CAN_NOT_GET_PLAN_RATES_FOR_PLAN_MESSAGE = 'Can\'t get plan rates for plan "%s".';
    const CAN_NOT_GET_PLAN_DETAILS_MESSAGE = 'Can\'t get details for plan "%s".';
    const CAN_NOT_START_SUBSCRIPTION_BY_ID_MESSAGE = 'Can\'t start subscription with ID "%s".';
    const CAN_NOT_SPLIT_DELIVER_LINES_FOR_VENDOR_BY_DATE_MESSAGE = 'Can\'t split deliver lines for vendor %s by date %s.';
    const CAN_NOT_MERGE_DELIVER_LINES_FOR_PERIOD_BY_VENDOR_MESSAGE = 'Can\'t merge deliver lines for period from %s to $s by vendor %s.';
    const CAN_NOT_GET_DELIVER_LINES_FOR_PERIOD_BY_VENDOR_LIST_MESSAGE = 'Can\'t get deliver lines for period from %s to $s by vendor %s.';
    const CAN_NOT_GET_PLAN_HISTORY_LIST_MESSAGE = 'Can\'t get history list for plan %s.';
    const CAN_NOT_GET_PLAN_FROM_ARCHIVE_MESSAGE = 'Can\'t get plan %s from archive by user %s and date %s.';
    const CAN_NOT_GET_PUBLICATION_STATUS_FOR_PLAN_MESSAGE = 'Can\'t get publication status for plan %s.';
    const CAN_NOT_UPDATE_PUBLICATION_STATUS_FOR_PLAN_MESSAGE = 'Can\'t update publication status for plan %s.';
    const CAN_NOT_GET_DISCOUNTED_RESOURCES_BY_DISCOUNT_MESSAGE = 'Can\'t get discounted resources by discount %s.';
    const CAN_NOT_GET_DISCOUNTED_PLANS_BY_DISCOUNT_MESSAGE = 'Can\'t get discounted plans by discount %s.';
    const CAN_NOT_GET_ORDER_DETAIL_MESSAGE = 'Can\'t get order detail %s.';
    const CAN_NOT_GET_PLAN_PERIOD_MESSAGE = 'Can\'t get plan period %s.';
    const CAN_NOT_PLACE_SUBSCRIPTION_CANCELLATION_ORDER_MESSAGE = 'Can\'t place cancellation order for subscription "%s".';
    const CAN_NOT_GET_AND_VALIDATE_PLAN_PARAMETERS_MESSAGE = 'Can\'t get and validate parameters for the plan "%s".';
    const CAN_NOT_GET_ATTRIBUTES_TYPE_LIST_MESSAGE = 'Can\'t get attributes type list.';
    const CAN_NOT_GET_PLAN_RATE_LIST_FULL_MESSAGE = 'Can\'t get plan rate list by service plan with id "%s".';
    const CAN_NOT_GET_CUSTOMER_SUBSCRIPTION_LIST_MESSAGE = 'Can\'t get subscriptions for customer "%s".';
    const CAN_NOT_GET_SUBSCRIPTION_LIST_BY_ORDER_MESSAGE = 'Can\'t get subscriptions list by order "%s".';

    const DISCOUNT_FOR_ACCOUNT_ALREADY_EXISTS = '0x127f8853';
    const SUBSCRIPTION_PARAMETER_DOES_NOT_EXIST_PA_6_0 = '0x52049a14';
    const SUBSCRIPTION_PARAMETER_DOES_NOT_EXIST_PA_7_0 = '0x631252e6';

    /**
     * @return bool
     */
    public function isSubscriptionParameterNotExistsException()
    {
        if (!$this->isXmlRpcException()) {
            return false;
        }
        /**
         * @var Service_PbaApi_Client_XmlRpcException $previous
         */
        $previous = $this->getPrevious();
        return $previous->getCode() == -1
            &&
            ($previous->getErrorCodeFromMessage() == self::SUBSCRIPTION_PARAMETER_DOES_NOT_EXIST_PA_6_0
                || $previous->getErrorCodeFromMessage() == self::SUBSCRIPTION_PARAMETER_DOES_NOT_EXIST_PA_7_0);
    }

    /**
     * @return bool
     */
    public function isXmlRpcException()
    {
        $previous = $this->getPrevious();
        return !is_null($previous) && $previous instanceof Service_PbaApi_Client_XmlRpcException;
    }

    /**
     * @return bool
     */
    public function isDiscountForAccountAlreadyExistsException()
    {
        if (!$this->isXmlRpcException()) {
            return false;
        }
        /**
         * @var Service_PbaApi_Client_XmlRpcException $previous
         */
        $previous = $this->getPrevious();
        return $previous->getCode() == -1 && $previous->getErrorCodeFromMessage() == self::DISCOUNT_FOR_ACCOUNT_ALREADY_EXISTS;
    }
}
