<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Request_ChangeOrderStatus extends Service_PbaApi_Client_Request
{
    const METHOD = 'OrderStatusChange_API';

    /**
     * Service_PbaApi_Api_Request_ChangeOrderStatus constructor.
     * @param int $orderId
     * @param string $status
     * @param string $signature
     */
    public function __construct($orderId, $status, $signature)
    {
        parent::__construct(
            self::METHOD,
            array(
                (int)$orderId,
                (string)$status,
                (string)$signature
            )
        );
    }

    /**
     * Method returns details of specified subscription.
     *
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_ChangeOrderStatus
     */
    public function getExpectedResponse(array $responseArray = null)
    {
        return new Service_PbaApi_Api_Response_ChangeOrderStatus($responseArray);
    }
}
