<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Request_StartSubscription extends Service_PbaApi_Client_Request
{
    const METHOD = 'SubscriptionStart_API';

    /**
     * @param int $subscriptionId
     * @param int $reasonId
     * @param string $description
     */
    public function __construct($subscriptionId, $reasonId, $description)
    {
        parent::__construct(self::METHOD, array(
            (int)$subscriptionId,
            (int)$reasonId,
            $description
        ));
    }

    /**
     * Method returns status of changed subscription.
     *
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_UpdateSubscriptionStatus
     */
    public function getExpectedResponse(array $responseArray = null)
    {
        return new Service_PbaApi_Api_Response_StartSubscription($responseArray);
    }
}

