<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Request_UpdatePlanPublicationStatus extends Service_PbaApi_Client_Request
{
    const METHOD = 'SavePublicationStatus';

    /**
     * @param int $planId
     * @param int $published
     * @param int $showPriority
     * @param int $defaultPlanPeriodId
     */
    public function __construct($planId, $published, $showPriority, $defaultPlanPeriodId)
    {
        parent::__construct(self::METHOD, array(
            (int)$planId,
            (int)$published,
            (int)$showPriority,
            (int)$defaultPlanPeriodId,
        ));
    }

    /**
     * Method returns details of specified subscription.
     *
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_UpdatePlanPublicationStatus
     */
    public function getExpectedResponse(array $responseArray = NULL)
    {
        return new Service_PbaApi_Api_Response_UpdatePlanPublicationStatus($responseArray);
    }
}
