<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetAttributesTypeList extends Service_PbaApi_Client_Response
{
    const EMPTY_RESULT = 'Empty result';

    /**
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_Struct_AttributeTypeListItem[]
     * @throws Service_PbaApi_Client_InvalidPropertyException
     */
    protected function _init(array $responseArray = NULL)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EMPTY_RESULT);
        }

        $list = array();
        $listData = $this->_getProperty(0, $responseArray);
        foreach ($listData as $itemData) {
            $list[] = $this->initListItem($itemData);
        }
        return $list;
    }

    /**
     * @param $itemData
     * @return Service_PbaApi_Api_Response_Struct_AttributeTypeListItem
     */
    protected function initListItem($itemData)
    {
        $item = new Service_PbaApi_Api_Response_Struct_AttributeTypeListItem();
        $item->setAttributeId($this->_getProperty(0, $itemData));
        $item->setName($this->_getProperty(1, $itemData));
        $item->setDescription($this->_getProperty(2, $itemData));
        $item->setType($this->_getProperty(3, $itemData));
        $item->setGroup($this->_getProperty(4, $itemData));
        $item->setStatus($this->_getProperty(5, $itemData));
        $item->setAfterField($this->_getProperty(6, $itemData));
        $item->setAttributeType($this->_getProperty(7, $itemData));
        $item->setActive($this->_getProperty(8, $itemData));
        $item->setSortNumber($this->_getProperty(9, $itemData));
        $item->setShowInStoreFront($this->_getProperty(10, $itemData));
        $item->setValidator($this->_getProperty(11, $itemData));
        $item->setComment($this->_getProperty(12, $itemData));
        $item->setUniqueSetting($this->_getProperty(13, $itemData));
        $item->setTags($this->_getProperty(14, $itemData));
        $item->setVendorId($this->_getProperty(15, $itemData));
        $item->setDataTypeId($this->_getProperty(16, $itemData));
        return $item;
    }
}
