<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetDiscountedResourceList extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    /**
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_Struct_DiscountedResourceListItem[]
     * @throws Service_PbaApi_Client_InvalidPropertyException
     */
    protected function _init(array $responseArray = NULL)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $list = array();
        $listData = $this->_getProperty(0, $responseArray);
        foreach ($listData as $itemData) {
            $list[] = $this->_initListItem($itemData);
        }
        return $list;
    }

    /**
     * @param $itemData
     * @return Service_PbaApi_Api_Response_Struct_DiscountedResourceListItem
     */
    private function _initListItem($itemData)
    {
        $item = new Service_PbaApi_Api_Response_Struct_DiscountedResourceListItem();
        $item->setResourceId($this->_getProperty(0, $itemData));
        $item->setResourceName($this->_getProperty(1, $itemData));
        $item->setResourceMaxValue($this->_getProperty(2, $itemData));
        $item->setResourceMinValue($this->_getProperty(3, $itemData));
        $item->setMeasurementUnitName($this->_getProperty(4, $itemData));
        return $item;
    }
}
