<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetOrderDetails extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $list = array();
        $listData = $this->_getProperty(0, $responseArray);
        foreach ($listData as $itemData) {
            $item = new Service_PbaApi_Api_Response_Struct_GetOrderDetails();
            $item->setSortNo($this->_getProperty(0, $itemData));
            $item->setDetailID($this->_getProperty(1, $itemData));
            $item->setDescription($this->_getProperty(2, $itemData));
            $item->setDetailType($this->_getProperty(3, $itemData));
            $item->setQuantity($this->_getProperty(4, $itemData));
            $item->setUom($this->_getProperty(5, $itemData));
            $item->setUnitPrice($this->_getProperty(6, $itemData));
            $item->setDiscountAmount($this->_getProperty(7, $itemData));
            $item->setExtendedPrice($this->_getProperty(8, $itemData));
            $item->setTaxCategory($this->_getProperty(9, $itemData));
            $item->setSubscription($this->_getProperty(10, $itemData));
            $item->setDuration($this->_getProperty(11, $itemData));
            $item->setBillingPeriod($this->_getProperty(12, $itemData));
            $item->setBillingPeriodType($this->_getProperty(13, $itemData));
            $item->setPromoID($this->_getProperty(14, $itemData));
            $item->setResourceID($this->_getProperty(15, $itemData));
            $item->setIsPromotedResource($this->_getProperty(16, $itemData));
            $item->setPlanPeriodID($this->_getProperty(17, $itemData));
            $item->setOriginalPlanID($this->_getProperty(18, $itemData));
            $item->setNewPlanID($this->_getProperty(19, $itemData));
            $item->setOrderDetailStartDate($this->_getProperty(20, $itemData));
            $item->setOrderDetailEndDate($this->_getProperty(21, $itemData));
            $list[] = $item;
        }
        return $list;
    }
}
