<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetOrderProvisioningItemsList extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $list = array();
        $listData = $this->_getProperty(0, $responseArray);
        foreach ($listData as $itemData) {
            $item = new Service_PbaApi_Api_Response_Struct_OrderProvisioningItem();
            $item->setOrderId($this->_getProperty(0, $itemData));
            $item->setParentOrderItemId($this->_getProperty(1, $itemData));
            $item->setOrderItemType($this->_getProperty(2, $itemData));
            $item->setOrderDocOrderId($this->_getProperty(3, $itemData));
            $item->setStatus($this->_getProperty(4, $itemData));
            $item->setStatusDesired($this->_getProperty(5, $itemData));
            $item->setProcessingComment($this->_getProperty(6, $itemData));
            $item->setStartDate($this->_getProperty(7, $itemData));
            $item->setEndDate($this->_getProperty(8, $itemData));
            $item->setLastDate($this->_getProperty(9, $itemData));
            $item->setDescription($this->_getProperty(10, $itemData));
            $item->setCreateTime($this->_getProperty(11, $itemData));
            $item->setApplyTime($this->_getProperty(12, $itemData));
            $item->setPlanId($this->_getProperty(13, $itemData));
            $item->setPlanPeriodId($this->_getProperty(14, $itemData));
            $item->setParentPlanId($this->_getProperty(15, $itemData));
            $item->setParentSubscriptionPeriod($this->_getProperty(16, $itemData));
            $item->setParentSubscriptionPeriodType($this->_getProperty(17, $itemData));
            $item->setSubscriptionId($this->_getProperty(18, $itemData));
            $list[] = $item;
        }
        return $list;
    }
}
