<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetPlanFromArchive extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        // Available fields:
        //    PlanID
        //    name
        //    serviceTemplateID
        //    planCategoryID
        //    ServTermID
        //    shortDescription
        //    longDescription
        //    GroupID
        //    published
        //    attachUsageStatistics
        //    AccountID
        //    NotificationTmpl
        //    ScheduleID
        //    ClassIDClassID
        //    BillingPeriodType
        //    BillingPeriod
        //    PricePeriodType
        //    RecurringType
        //    IsAutoRenew
        //    RenewPointType
        //    RenewOrderInterval
        //    AutoRenew_PlanPeriodID
        //    ShowPriority
        //    Default_PlanPeriodID
        //    ImageID
        //    Locked
        //    Managed
        //    Copied_From_PlanID
        $planData = $this->_getProperty(0, $responseArray);

        $plan = new Service_PbaApi_Api_Response_Struct_PlanArchive();
        $plan->setPlanId($this->_getProperty(0, $planData));
        $plan->setName($this->_getProperty(1, $planData));
        $plan->setServiceTemplateId($this->_getProperty(2, $planData));

        $plan->setCopiedFromPlanId($this->_getProperty(27, $planData, false));

        return $plan;
    }
}
