<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetPlanFromArchive extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    const OFFSET_PLAN_ID = 0;
    const OFFSET_NAME = 2;
    const OFFSET_SERVICE_TEMPLATE_ID = 3;
    const OFFSET_COPIED_FROM_PLAN_ID = 28;

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        // Available fields:
        //    PlanID
        //    ApsUUID
        //    name
        //    serviceTemplateID
        //    planCategoryID
        //    ServTermID
        //    shortDescription
        //    longDescription
        //    GroupID
        //    published
        //    attachUsageStatistics
        //    AccountID
        //    NotificationTmpl
        //    ScheduleID
        //    ClassIDClassID
        //    BillingPeriodType
        //    BillingPeriod
        //    PricePeriodType
        //    RecurringType
        //    IsAutoRenew
        //    RenewPointType
        //    RenewOrderInterval
        //    AutoRenew_PlanPeriodID
        //    ShowPriority
        //    Default_PlanPeriodID
        //    ImageID
        //    Locked
        //    Managed
        //    Copied_From_PlanID
        //    ParentVersion
        //    Version
        //    UserArc
        //    DateArc
        $planData = $this->_getProperty(0, $responseArray);

        $plan = new Service_PbaApi_Api_Response_Struct_PlanArchive();
        $plan->setPlanId($this->_getProperty(self::OFFSET_PLAN_ID, $planData));
        $plan->setName($this->_getProperty(self::OFFSET_NAME, $planData));
        $plan->setServiceTemplateId($this->_getProperty(self::OFFSET_SERVICE_TEMPLATE_ID, $planData));
        $plan->setCopiedFromPlanId($this->_getProperty(self::OFFSET_COPIED_FROM_PLAN_ID, $planData, false));

        return $plan;
    }
}
