<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetPlanHistoryList extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $list = array();
        $listData = $this->_getProperty(0, $responseArray);
        foreach ($listData as $lineData) {
            $list[] = $this->fetchHistoryRecord($lineData);
        }
        return $list;
    }

    private function fetchHistoryRecord($recordData)
    {
        $historyRecord = new Service_PbaApi_Api_Response_Struct_PlanHistoryListItem();
        $historyRecord->setPlanId($this->_getProperty(0, $recordData));
        $historyRecord->setUserId($this->_getProperty(1, $recordData));
        $historyRecord->setDate($this->_getProperty(2, $recordData));
        $historyRecord->setPlanName($this->_getProperty(3, $recordData));
        $historyRecord->setServiceTemplateId($this->_getProperty(4, $recordData));
        $historyRecord->setPlanCategoryId($this->_getProperty(5, $recordData));
        $historyRecord->setServiceTermId($this->_getProperty(6, $recordData));
        return $historyRecord;
    }
}
