<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetSubscriptionDetailsEx extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    /**
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_Struct_SubscriptionDetailsEx
     * @throws Service_PbaApi_Client_InvalidPropertyException
     */
    protected function _init(array $responseArray = NULL)
    {
        if (is_null($responseArray))
        {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $responseData = $this->_getProperty(0, $responseArray);
        $subscription = new Service_PbaApi_Api_Response_Struct_SubscriptionDetailsEx();
        $subscription->setSubscriptionId($this->_getProperty(0, $responseData));
        $subscription->setSubscriptionName($this->_getProperty(1, $responseData));
        $subscription->setAccountId($this->_getProperty(2, $responseData));
        $subscription->setPlanId($this->_getProperty(3, $responseData));
        $subscription->setPlanName($this->_getProperty(4, $responseData));
        $subscription->setStatus($this->_getProperty(5, $responseData));
        $subscription->setServStatus($this->_getProperty(6, $responseData));
        $subscription->setStartDate($this->_getProperty(7, $responseData));
        $subscription->setExpirationDate($this->_getProperty(8, $responseData));
        $subscription->setLastBillDate($this->_getProperty(9, $responseData));
        $subscription->setNextBillDate($this->_getProperty(10, $responseData));
        $subscription->setBillingPeriodType($this->_getProperty(11, $responseData));
        $subscription->setBillingPeriod($this->_getProperty(12, $responseData));
        $subscription->setTrial($this->_getProperty(13, $responseData));
        $subscription->setShutdownDate($this->_getProperty(14, $responseData));
        $subscription->setTerminateDate($this->_getProperty(15, $responseData));
        $subscription->setPeriod($this->_getProperty(16, $responseData));
        $subscription->setPeriodType($this->_getProperty(17, $responseData));
        $subscription->setFreezePrices($this->_getProperty(18, $responseData));
        $subscription->setPromoCode($this->_getProperty(19, $responseData));
        return $subscription;
    }
}
