<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_Struct_AttributeTypeListItem
{
    /**
     * ID of attribute;
     * @var string
     */
    private $attributeId;

    /**
     * Attribute name;
     * @var string
     */
    private $name;

    /**
     * Attribute description;
     * @var string
     */
    private $description;

    /**
     * Attribute value type.
     * INT – integer,
     * STR – text up to 80 characters,
     * STRA – text over 80 characters,
     * DATE – date,
     * PASSWD – password,
     * NAME_LOGIN – login name,
     * DOMAIN_NAME – domain name;
     * @var string
     */
    private $type;

    /**
     * Attribute group name. Attributes with the same group displayed in online store under group name;
     * @var string
     */
    private $group;

    /**
     * Defines whether attribute is optional – 10, or required – 20;
     * @var integer
     */
    private $status;

    /**
     * Defines where the attribute should be located among other data fields which a customer has to fill in:
     * 1 – Address Line 1,
     * 2 – Address Line 2,
     * 3 – City,
     * 4 – Country,
     * 5 – Email Address,
     * 6 – Phone,
     * 7 – Fax,
     * 8 – First Name,
     * 9 – Last Name,
     * 10 – Company,
     * 11 – Postal address,
     * 12 – Tax,
     * 13 – State/Province,
     * 14 – Zip code,
     * 15 – Login;
     * @var integer
     */
    private $afterField;

    /**
     * Defines attribute type:
     * 0 – available for accounts,
     * 1 – available for users,
     * 2 – available for orders;
     * @var integer
     */
    private $attributeType;

    /**
     * Defines whether attribute is active – 1 or not – 0;
     * @var integer
     */
    private $active;

    /**
     * Attribute sort number. It works together with the After Field option.
     * If a number of attributes have same the After Field parameter value,
     * the parameter defines sort number for them.
     * @var integer
     */
    private $sortNumber;

    /**
     * Signifies whether to display an attribute in online store -1 or only on creating account from CP – 0;
     * @var integer
     */
    private $showInStoreFront;

    /**
     * The regular expression against which the value of attribute will be validated;
     * @var string
     */
    private $validator;

    /**
     * The attribute's hint that is displayed on screen;
     * @var string
     */
    private $comment;

    /**
     * Specifies whether the attribute value should be unique:
     * 0 – Not unique,
     * 10 – Unique per Vendor,
     * 20 – Unique globally;
     * @var integer
     */
    private $uniqueSetting;

    /**
     * Attribute tags:
     * COMP, PERS are system predefined tags and refer to the company and personal accounts, respectively;
     * @var string
     */
    private $tags;

    /**
     * ID of the vendor under which the attribute was created;
     * @var integer
     */
    private $vendorId;

    /**
     * Unique ID of the attribute's data type.
     * @var integer
     */
    private $dataTypeId;

    /**
     * @return string
     */
    public function getAttributeId()
    {
        return $this->attributeId;
    }

    /**
     * @param string $attributeId
     */
    public function setAttributeId($attributeId)
    {
        $this->attributeId = $attributeId;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }

    /**
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }

    /**
     * @return string
     */
    public function getGroup()
    {
        return $this->group;
    }

    /**
     * @param string $group
     */
    public function setGroup($group)
    {
        $this->group = $group;
    }

    /**
     * @return int
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * @param int $status
     */
    public function setStatus($status)
    {
        $this->status = $status;
    }

    /**
     * @return int
     */
    public function getAfterField()
    {
        return $this->afterField;
    }

    /**
     * @param int $afterField
     */
    public function setAfterField($afterField)
    {
        $this->afterField = $afterField;
    }

    /**
     * @return int
     */
    public function getAttributeType()
    {
        return $this->attributeType;
    }

    /**
     * @param int $attributeType
     */
    public function setAttributeType($attributeType)
    {
        $this->attributeType = $attributeType;
    }

    /**
     * @return int
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * @param int $active
     */
    public function setActive($active)
    {
        $this->active = $active;
    }

    /**
     * @return int
     */
    public function getSortNumber()
    {
        return $this->sortNumber;
    }

    /**
     * @param int $sortNumber
     */
    public function setSortNumber($sortNumber)
    {
        $this->sortNumber = $sortNumber;
    }

    /**
     * @return int
     */
    public function getShowInStoreFront()
    {
        return $this->showInStoreFront;
    }

    /**
     * @param int $showInStoreFront
     */
    public function setShowInStoreFront($showInStoreFront)
    {
        $this->showInStoreFront = $showInStoreFront;
    }

    /**
     * @return string
     */
    public function getValidator()
    {
        return $this->validator;
    }

    /**
     * @param string $validator
     */
    public function setValidator($validator)
    {
        $this->validator = $validator;
    }

    /**
     * @return string
     */
    public function getComment()
    {
        return $this->comment;
    }

    /**
     * @param string $comment
     */
    public function setComment($comment)
    {
        $this->comment = $comment;
    }

    /**
     * @return int
     */
    public function getUniqueSetting()
    {
        return $this->uniqueSetting;
    }

    /**
     * @param int $uniqueSetting
     */
    public function setUniqueSetting($uniqueSetting)
    {
        $this->uniqueSetting = $uniqueSetting;
    }

    /**
     * @return string
     */
    public function getTags()
    {
        return $this->tags;
    }

    /**
     * @param string $tags
     */
    public function setTags($tags)
    {
        $this->tags = $tags;
    }

    /**
     * @return int
     */
    public function getVendorId()
    {
        return $this->vendorId;
    }

    /**
     * @param int $vendorId
     */
    public function setVendorId($vendorId)
    {
        $this->vendorId = $vendorId;
    }

    /**
     * @return int
     */
    public function getDataTypeId()
    {
        return $this->dataTypeId;
    }

    /**
     * @param int $dataTypeId
     */
    public function setDataTypeId($dataTypeId)
    {
        $this->dataTypeId = $dataTypeId;
    }
}
