<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_Struct_OrderProvisioningItem
{
    /**
     * order ID;
     * @var int
     */
    private $orderId;

    /**
     * ID of parent order item to which current item subjects;
     * @var int
     */
    private $parentOrderItemId;

    /**
     * type of order item (creation, upgrade, etc.);
     * @var int
     */
    private $orderItemType;

    /**
     * ID of order this order item comprises;
     * @var int
     */
    private $orderDocOrderId;

    /**
     * status of order item (new, provisioning, failed, etc.);
     * @var int
     */
    private $status;

    /**
     * target status of order item;
     * @var int
     */
    private $statusDesired;

    /**
     * comment from provision subsystem;
     * @var str
     */
    private $processingComment;

    /**
     * start date of order item execution;
     * @var int
     */
    private $startDate;

    /**
     * end date of order item execution;
     * @var int
     */
    private $endDate;

    /**
     * last provisioning order date;
     * @var int
     */
    private $lastDate;

    /**
     * description;
     * @var str
     */
    private $description;

    /**
     * time of creation;
     * @var int
     */
    private $createTime;

    /**
     * time of application to service;
     * @var int
     */
    private $applyTime;

    /**
     * plan ID this order item refers to;
     * @var int
     */
    private $planId;

    /**
     * plan period ID this order item refers to;
     * @var int
     */
    private $planPeriodId;

    /**
     * parent plan ID for plan referenced by PlanID;
     * @var int
     */
    private $parentPlanId;

    /**
     * subscription plan period for plan referenced by PlanID;
     * @var int
     */
    private $parentSubscriptionPeriod;

    /**
     * type of subscription period referenced by ParentSubscrPeriod;
     * @var int
     */
    private $parentSubscriptionPeriodType;

    /**
     * subscription ID this order item is applicable to.
     * @var int
     */
    private $subscriptionId;

    /**
     * @return int
     */
    public function getOrderId()
    {
        return $this->orderId;
    }

    /**
     * @param int $orderId
     */
    public function setOrderId($orderId)
    {
        $this->orderId = $orderId;
    }

    /**
     * @return int
     */
    public function getParentOrderItemId()
    {
        return $this->parentOrderItemId;
    }

    /**
     * @param int $parentOrderItemId
     */
    public function setParentOrderItemId($parentOrderItemId)
    {
        $this->parentOrderItemId = $parentOrderItemId;
    }

    /**
     * @return int
     */
    public function getOrderItemType()
    {
        return $this->orderItemType;
    }

    /**
     * @param int $orderItemType
     */
    public function setOrderItemType($orderItemType)
    {
        $this->orderItemType = $orderItemType;
    }

    /**
     * @return int
     */
    public function getOrderDocOrderId()
    {
        return $this->orderDocOrderId;
    }

    /**
     * @param int $orderDocOrderId
     */
    public function setOrderDocOrderId($orderDocOrderId)
    {
        $this->orderDocOrderId = $orderDocOrderId;
    }

    /**
     * @return int
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * @param int $status
     */
    public function setStatus($status)
    {
        $this->status = $status;
    }

    /**
     * @return int
     */
    public function getStatusDesired()
    {
        return $this->statusDesired;
    }

    /**
     * @param int $statusDesired
     */
    public function setStatusDesired($statusDesired)
    {
        $this->statusDesired = $statusDesired;
    }

    /**
     * @return str
     */
    public function getProcessingComment()
    {
        return $this->processingComment;
    }

    /**
     * @param str $processingComment
     */
    public function setProcessingComment($processingComment)
    {
        $this->processingComment = $processingComment;
    }

    /**
     * @return int
     */
    public function getStartDate()
    {
        return $this->startDate;
    }

    /**
     * @param int $startDate
     */
    public function setStartDate($startDate)
    {
        $this->startDate = $startDate;
    }

    /**
     * @return int
     */
    public function getEndDate()
    {
        return $this->endDate;
    }

    /**
     * @param int $endDate
     */
    public function setEndDate($endDate)
    {
        $this->endDate = $endDate;
    }

    /**
     * @return int
     */
    public function getLastDate()
    {
        return $this->lastDate;
    }

    /**
     * @param int $lastDate
     */
    public function setLastDate($lastDate)
    {
        $this->lastDate = $lastDate;
    }

    /**
     * @return str
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * @param str $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }

    /**
     * @return int
     */
    public function getCreateTime()
    {
        return $this->createTime;
    }

    /**
     * @param int $createTime
     */
    public function setCreateTime($createTime)
    {
        $this->createTime = $createTime;
    }

    /**
     * @return int
     */
    public function getApplyTime()
    {
        return $this->applyTime;
    }

    /**
     * @param int $applyTime
     */
    public function setApplyTime($applyTime)
    {
        $this->applyTime = $applyTime;
    }

    /**
     * @return int
     */
    public function getPlanId()
    {
        return $this->planId;
    }

    /**
     * @param int $planId
     */
    public function setPlanId($planId)
    {
        $this->planId = $planId;
    }

    /**
     * @return int
     */
    public function getPlanPeriodId()
    {
        return $this->planPeriodId;
    }

    /**
     * @param int $planPeriodId
     */
    public function setPlanPeriodId($planPeriodId)
    {
        $this->planPeriodId = $planPeriodId;
    }

    /**
     * @return int
     */
    public function getParentPlanId()
    {
        return $this->parentPlanId;
    }

    /**
     * @param int $parentPlanId
     */
    public function setParentPlanId($parentPlanId)
    {
        $this->parentPlanId = $parentPlanId;
    }

    /**
     * @return int
     */
    public function getParentSubscriptionPeriod()
    {
        return $this->parentSubscriptionPeriod;
    }

    /**
     * @param int $parentSubscriptionPeriod
     */
    public function setParentSubscriptionPeriod($parentSubscriptionPeriod)
    {
        $this->parentSubscriptionPeriod = $parentSubscriptionPeriod;
    }

    /**
     * @return int
     */
    public function getParentSubscriptionPeriodType()
    {
        return $this->parentSubscriptionPeriodType;
    }

    /**
     * @param int $parentSubscriptionPeriodType
     */
    public function setParentSubscriptionPeriodType($parentSubscriptionPeriodType)
    {
        $this->parentSubscriptionPeriodType = $parentSubscriptionPeriodType;
    }

    /**
     * @return int
     */
    public function getSubscriptionId()
    {
        return $this->subscriptionId;
    }

    /**
     * @param int $subscriptionId
     */
    public function setSubscriptionId($subscriptionId)
    {
        $this->subscriptionId = $subscriptionId;
    }
}
