<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_Struct_SubscriptionResourcesList implements Service_PbaApi_Api_Response_Struct_SubscriptionResourcesListInterface
{

    /**
     * @var integer
     */
    private $resourceId;

    /**
     * @var integer
     */
    private $resourceRateId;

    /**
     * @var string
     */
    private $resourceName;

    /**
     * @var string
     */
    private $storeDescription;

    /**
     * @var string
     */
    private $storePriceText;

    /**
     * @var integer
     */
    private $storeSortOrder;

    /**
     * Possible values:
     * Purchased - If the subscription to this resource is not active, this status means that the resource is included in it. If the subscription is active, the status means that the resource is purchased for this subscription.
     * Provisioning - This status means that the resource will be installed soon for the specified subscription.
     * Installed - This status means the resource is installed.
     * Failed - This status means some technical problems occurred while processing the order for this resource or resource installation.
     * Ordered - This status means the resource is ordered for the specified subscription.
     * Not Included - This status is obsolete, similar to Optional.
     * Removing - This status means the resource is removing from the subscription.
     * Disabled - This status means the resource is disabled in case of the subscription cancellation.
     * Optional - This status means the resources can be purchased to the subscription additionally.
     *
     * @var string
     */
    private $status;

    /**
     * @var string
     */
    private $resourceCategory;

    /**
     * @var double
     */
    private $includedAmount;

    /**
     * @var double
     */
    private $additionalAmount;

    /**
     * @var double
     */
    private $usedAmount;

    /**
     * @var double
     */
    private $orderedAmount;


    /**
     * @var string
     */
    private $unit;

    /**
     * @var integer
     */
    private $minUnits;

    /**
     * @var integer
     */
    private $maxUnits;

    /**
     * @var integer
     */
    private $measurable;

    /**
     * Possible value:
     * Standard - The resource was added to the subscription upon a service plan purchase.
     * Switch Plan - The resource was added to the subscription when the subscription plan was changed.
     * Additional - The resource was added to the plan after the subscription was provisioned.
     * Sync With Plan - The plan was changed after the subscription was provisioned and synchronized with the plan.
     * Upgrade / Downgrade - Additional resource units were ordered after the initial resources provisioning.
     *
     * @var string
     */
    private $relativeStatus;

    /**
     * @var string
     */
    private $orderNumber;

    /**
     * @var double
     */
    private $setupFee;

    /**
     * @var double
     */
    private $recurringFee;

    /**
     * @var double
     */
    private $overuseFee;

    /**
     * @var string
     */
    private $location;

    /**
     * Possible value:
     * Subscription - The resource exists only in the subscription, and its resource rate was removed from the service plan.
     * ServicePlan - The resource rate exists in the service plan for this resource, but the resource is not purchased for the subscription.
     * Both - The resource exists both in the service plan and subscription.
     * @var integer
     */
    private $isOveruseFeeTiered;

    /**
     * @var integer
     */
    private $isRecurringFeeTiered;

    /**
     * @var integer
     */
    private $isSetupFeeTiered;

    /**
     * @return int
     */
    public function getResourceId()
    {
        return $this->resourceId;
    }

    /**
     * @param int $resourceId
     */
    public function setResourceId($resourceId)
    {
        $this->resourceId = $resourceId;
    }

    /**
     * @return int
     */
    public function getResourceRateId()
    {
        return $this->resourceRateId;
    }

    /**
     * @param int $resourceRateId
     */
    public function setResourceRateId($resourceRateId)
    {
        $this->resourceRateId = $resourceRateId;
    }

    /**
     * @return string
     */
    public function getResourceName()
    {
        return $this->resourceName;
    }

    /**
     * @param string $resourceName
     */
    public function setResourceName($resourceName)
    {
        $this->resourceName = $resourceName;
    }

    /**
     * @return string
     */
    public function getStoreDescription()
    {
        return $this->storeDescription;
    }

    /**
     * @param string $storeDescription
     */
    public function setStoreDescription($storeDescription)
    {
        $this->storeDescription = $storeDescription;
    }

    /**
     * @return string
     */
    public function getStorePriceText()
    {
        return $this->storePriceText;
    }

    /**
     * @param string $storePriceText
     */
    public function setStorePriceText($storePriceText)
    {
        $this->storePriceText = $storePriceText;
    }

    /**
     * @return int
     */
    public function getStoreSortOrder()
    {
        return $this->storeSortOrder;
    }

    /**
     * @param int $storeSortOrder
     */
    public function setStoreSortOrder($storeSortOrder)
    {
        $this->storeSortOrder = $storeSortOrder;
    }

    /**
     * @return string
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * @param string $status
     */
    public function setStatus($status)
    {
        $this->status = $status;
    }

    /**
     * @return string
     */
    public function getResourceCategory()
    {
        return $this->resourceCategory;
    }

    /**
     * @param string $resourceCategory
     */
    public function setResourceCategory($resourceCategory)
    {
        $this->resourceCategory = $resourceCategory;
    }

    /**
     * @return float
     */
    public function getIncludedAmount()
    {
        return $this->includedAmount;
    }

    /**
     * @param float $includedAmount
     */
    public function setIncludedAmount($includedAmount)
    {
        $this->includedAmount = $includedAmount;
    }

    /**
     * @return float
     */
    public function getAdditionalAmount()
    {
        return $this->additionalAmount;
    }

    /**
     * @param float $additionalAmount
     */
    public function setAdditionalAmount($additionalAmount)
    {
        $this->additionalAmount = $additionalAmount;
    }

    /**
     * @return float
     */
    public function getUsedAmount()
    {
        return $this->usedAmount;
    }

    /**
     * @param float $usedAmount
     */
    public function setUsedAmount($usedAmount)
    {
        $this->usedAmount = $usedAmount;
    }

    /**
     * @return float
     */
    public function getOrderedAmount()
    {
        return $this->orderedAmount;
    }

    /**
     * @param float $orderedAmount
     */
    public function setOrderedAmount($orderedAmount)
    {
        $this->orderedAmount = $orderedAmount;
    }

    /**
     * @return string
     */
    public function getUnit()
    {
        return $this->unit;
    }

    /**
     * @param string $unit
     */
    public function setUnit($unit)
    {
        $this->unit = $unit;
    }

    /**
     * @return int
     */
    public function getMinUnits()
    {
        return $this->minUnits;
    }

    /**
     * @param int $minUnits
     */
    public function setMinUnits($minUnits)
    {
        $this->minUnits = $minUnits;
    }

    /**
     * @return int
     */
    public function getMaxUnits()
    {
        return $this->maxUnits;
    }

    /**
     * @param int $maxUnits
     */
    public function setMaxUnits($maxUnits)
    {
        $this->maxUnits = $maxUnits;
    }

    /**
     * @return int
     */
    public function getMeasurable()
    {
        return $this->measurable;
    }

    /**
     * @param int $measurable
     */
    public function setMeasurable($measurable)
    {
        $this->measurable = $measurable;
    }

    /**
     * @return string
     */
    public function getRelativeStatus()
    {
        return $this->relativeStatus;
    }

    /**
     * @param string $relativeStatus
     */
    public function setRelativeStatus($relativeStatus)
    {
        $this->relativeStatus = $relativeStatus;
    }

    /**
     * @return string
     */
    public function getOrderNumber()
    {
        return $this->orderNumber;
    }

    /**
     * @param string $orderNumber
     */
    public function setOrderNumber($orderNumber)
    {
        $this->orderNumber = $orderNumber;
    }

    /**
     * @return float
     */
    public function getSetupFee()
    {
        return $this->setupFee;
    }

    /**
     * @param float $setupFee
     */
    public function setSetupFee($setupFee)
    {
        $this->setupFee = $setupFee;
    }

    /**
     * @return float
     */
    public function getRecurringFee()
    {
        return $this->recurringFee;
    }

    /**
     * @param float $recurringFee
     */
    public function setRecurringFee($recurringFee)
    {
        $this->recurringFee = $recurringFee;
    }

    /**
     * @return float
     */
    public function getOveruseFee()
    {
        return $this->overuseFee;
    }

    /**
     * @param float $overuseFee
     */
    public function setOveruseFee($overuseFee)
    {
        $this->overuseFee = $overuseFee;
    }

    /**
     * @return string
     */
    public function getLocation()
    {
        return $this->location;
    }

    /**
     * @param string $location
     */
    public function setLocation($location)
    {
        $this->location = $location;
    }

    /**
     * @return int
     */
    public function getIsOveruseFeeTiered()
    {
        return $this->isOveruseFeeTiered;
    }

    /**
     * @param int $isOveruseFeeTiered
     */
    public function setIsOveruseFeeTiered($isOveruseFeeTiered)
    {
        $this->isOveruseFeeTiered = $isOveruseFeeTiered;
    }

    /**
     * @return int
     */
    public function getIsRecurringFeeTiered()
    {
        return $this->isRecurringFeeTiered;
    }

    /**
     * @param int $isRecurringFeeTiered
     */
    public function setIsRecurringFeeTiered($isRecurringFeeTiered)
    {
        $this->isRecurringFeeTiered = $isRecurringFeeTiered;
    }

    /**
     * @return int
     */
    public function getIsSetupFeeTiered()
    {
        return $this->isSetupFeeTiered;
    }

    /**
     * @param int $isSetupFeeTiered
     */
    public function setIsSetupFeeTiered($isSetupFeeTiered)
    {
        $this->isSetupFeeTiered = $isSetupFeeTiered;
    }
}
