<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

abstract class Service_PbaApi_Client_Request implements Service_PbaApi_Client_RequestInterface
{
    /** @var string */
    private $_method;

    /** @var array */
    private $_parameters;

    /** @var array */
    private $_language;

    /**
     * @param string $method
     * @param array|null $parameters
     * @param string|null $language
     */
    public function __construct($method, array $parameters = null, $language = null)
    {
        $this->_method = $method;
        $this->_parameters = $parameters;
        $this->_language = $language;
    }

    /**
     * @return string
     */
    public function getMethod()
    {
        return $this->_method;
    }

    /**
     * @return array
     */
    public function getParameters()
    {
        return $this->_parameters;
    }

    /**
     * @return array
     */
    public function getLanguage()
    {
        return $this->_language;
    }
}
