<?php
/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Services\AgentsManager;

use Arr;
use Service_AmsApiClient_Response_Struct_LinksListAgentsItem as Agent;

class AgentRule extends Agent
{
    private $userQuotas;

    private $category;

    public function __construct($ruleOptions)
    {
        $this->setArchitecture(Arr::get($ruleOptions, 'architecture'));
        $this->setSystem(Arr::get($ruleOptions, 'system'));
        $this->setType(Arr::get($ruleOptions, 'type'));
        $this->setWeb(Arr::get($ruleOptions, 'web'));
        $this->userQuotas = Arr::get($ruleOptions, 'user_quotas');
        $this->category = Arr::get($ruleOptions, 'category');
        $this->setTitle(Arr::get($ruleOptions, 'title'));
    }

    /**
     * @return string[]
     */
    public function getUserQuotas()
    {
        return $this->userQuotas;
    }

    /**
     * @return string
     */
    public function getCategory()
    {
        return $this->category;
    }
}