<?php
/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Services\BssApi;

use Acronis\App\Services\FactoryInterface;
use Service_PbaApi_Api as BssApi;
use Service_PbaApi_ApiInterface as BssApiInterface;
use Service_PbaApi_Client as BssApiClient;

class BssApiFactory implements FactoryInterface
{
    const NAME = 'bss_api';

    /**
     * @return BssApiInterface
     * @throws \Exception
     */
    public function createInstance()
    {
        $config = $this->getBssApiConfig();
        $xmlRpcClient = new BssApiClient($config->host, $config->port, $config->path, $config->secure);
        if ($config->auth) {
            $xmlRpcClient->setCredentials($config->username, $config->password);
        }

        return new BssApi($xmlRpcClient);
    }

    /**
     * @return object
     * @throws \Exception
     */
    private function getBssApiConfig()
    {
        return \Settings::getInstance()->getBillingConfig();
    }
}