<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Services\Redis;

use Acronis\App\Services\Config\ConfigAwareTrait;
use Acronis\App\Services\Config\ConfigSchema;
use Acronis\App\Services\FactoryInterface;
use Arr;

class RedisFactory implements FactoryInterface
{
    use ConfigAwareTrait;
    use PureRedisAwareTrait;

    const NAME = 'redis';

    /**
     * @return RedisClient
     */
    public function createInstance()
    {
        return new RedisClient($this->getPureRedis(), $this->getKeyPrefix());
    }

    /**
     * @return string
     */
    private function getKeyPrefix()
    {
        return Arr::get($this->getConfig()->getRedisConfig(), ConfigSchema::NODE_REDIS_PREFIX, '');
    }
}