<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Services\UsageReportManager;

use Acronis\App\Services\Config\ConfigSchema;
use Acronis\App\UsageReport\Manager;
use Acronis\App\Services\Config\ConfigAwareTrait;
use Acronis\App\Services\FactoryInterface;

class UsageReportManagerFactory implements FactoryInterface
{
    use ConfigAwareTrait;

    const NAME = 'usage_report';

    /**
     * @return Manager
     * @throws \Exception
     */
    public function createInstance()
    {
        return new Manager($this->getUsageReportConfig());
    }

    /**
     * @return mixed
     * @throws \Exception
     */
    private function getUsageReportConfig()
    {
        $usageReportConfig = $this->getConfig()->getUsageReportConfig();
        $relativeDownloadPath = $usageReportConfig[ConfigSchema::NODE_USAGE_REPORT_DOWNLOAD_PATH];
        $usageReportConfig[ConfigSchema::NODE_USAGE_REPORT_DOWNLOAD_PATH] = $this->getConfig()->getAbsolutePath($relativeDownloadPath);

        return $usageReportConfig;
    }
}