<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\UsageReport\Aggregation;

use Arr;

class Accumulator
{
    /** @var string */
    private $accumulatorId;

    /** @var float[] */
    private $usages;

    public function __construct($accumulatorId)
    {
        $this->accumulatorId = $accumulatorId;
        $this->usages = [];
    }

    /**
     * @return string
     */
    public function getId()
    {
        return $this->accumulatorId;
    }

    /**
     * @return float[]
     */
    public function getUsages()
    {
        return $this->usages;
    }

    /**
     * @param float[] $usages
     */
    public function setUsages(array $usages)
    {
        $this->usages = $usages;
    }

    /**
     * @param string $counterName
     * @param float $usage
     */
    public function addUsage($counterName, $usage)
    {
        Arr::increment($this->usages, $counterName, $usage);
    }
}