<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Arr
{
    const VALUE_DELIMITER = '=';
    const PAIR_DELIMITER = ';';

    /**
     * @param array $values
     * @return string
     */
    public static function encode(array $values)
    {
        $pairs = array();
        foreach ($values as $k => $v) {
            $pairs[] = is_null($v) ? $k : $k . self::VALUE_DELIMITER . $v;
        }

        return implode(self::PAIR_DELIMITER, $pairs);
    }

    /**
     * @param string $string
     * @return array
     */
    public static function decode($string)
    {
        if (!is_string($string) || $string === '') {
            return array();
        }

        $pairs = explode(self::PAIR_DELIMITER, $string);

        $values = array();
        foreach ($pairs as $pair) {
            $parts = explode(self::VALUE_DELIMITER, $pair, 2);
            $values[$parts[0]] = count($parts) > 1 ? $parts[1] : null;
        }
        return $values;
    }
}
