<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

abstract class Enum
{
    /** @var int */
    private $_value;

    /**
     * @param int $value
     * @throws InvalidArgumentException
     */
    public function __construct($value)
    {
        $className = get_class($this);
        $reflection = new ReflectionClass($className);
        $constants = array_flip($reflection->getConstants());
        if (!array_key_exists($value, $constants))
        {
            throw new InvalidArgumentException('Incorrect enum value: ' . $value);
        }
        $this->_value = $value;
    }

    /**
     * @return int
     */
    public function getValue()
    {
        return $this->_value;
    }
}
