<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Session_StoreStub implements Session_StoreInterface
{
    /**
     * @var Session_StoreStub
     */
    private static $instance = null;

    /**
     * Singleton implementation
     *
     * @return Session_StoreStub object
     */
    public static function getInstance()
    {
        if (is_null(self::$instance)) {
            self::$instance = new Session_StoreStub();
        }
        return self::$instance;
    }

    /**
     * Set session id
     *
     * @param $id
     * @return string
     */
    public function setSessionId($id)
    {
        return '';
    }

    /**
     * start session if it's not started
     *
     * @return true
     */
    public function startSession()
    {
        //Do nothing
        return true;
    }

    /**
     * stop session if it's started
     * @return boolean
     */
    public function stopSession()
    {
        //Do nothing
        return true;
    }

    /**
     * increse for session_lifetime current expire value for key
     * @param string $key
     */
    public function increaseExpireTime($key)
    {
        //Do nothing
    }

    /**
     * Sets value to session by key and create expire time for this value
     *
     * @param string $key
     * @param mixed $value
     * @param int|null $ttl
     */
    public function setValue($key, $value, $ttl = null)
    {
        //Do nothing
    }

    /**
     * Return value from session by key and update expire time
     *
     * @param string $key
     * @return mixed
     */
    public function getValue($key)
    {
        //Do nothing
        return null;
    }

    /**
     * Check that session value by key is not expired
     *
     * @param string $key
     * @return bool
     */
    public function isExpired($key)
    {
        //Do nothing
        return false;
    }

    /**
     * Delete value from session by key
     *
     * @param string $key
     * @return mixed
     */
    public function unsetValue($key)
    {
        return null;
    }
}
