<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
 

class Time
{

    const DEFAULT_TIMEZONE = 'UTC';
    const DEFAULT_DATE_FORMAT = 'Y-m-d';
    const DEFAULT_DATE_TIME_FORMAT = 'Y-m-d H:i:s';

    /**
     * @param int $seconds
     * @return int
     */
    public function sleep($seconds)
    {
        return sleep($seconds);
    }

    public static function formatDate(DateTime $localDate, $format = self::DEFAULT_DATE_FORMAT, $timezone = self::DEFAULT_TIMEZONE)
    {
        if (!is_null($timezone)) {
            $localDate->setTimezone(new DateTimeZone($timezone));
        }

        return $localDate->format($format);
    }

    /**
     * @param string $timeZone
     * @param string $dateFormat
     * @param int $dayOffset
     * @return string
     */
    public static function getCurentDate($timeZone = self::DEFAULT_TIMEZONE, $dateFormat = self::DEFAULT_DATE_FORMAT, $dayOffset = 0)
    {
        $timezone = new DateTimeZone($timeZone);
        $currentDate = static::offsetDate(new DateTime('now', $timezone), $dayOffset);

        return $currentDate->format($dateFormat);
    }

    /**
     * @param string $timeZone
     * @param string $dateFormat
     * @param int $dayOffset
     * @return string
     */
    public static function getCurentDateTime($timeZone = self::DEFAULT_TIMEZONE, $dateFormat = self::DEFAULT_DATE_TIME_FORMAT, $dayOffset = 0)
    {
        return static::getCurentDate($timeZone, $dateFormat, $dayOffset);
    }

    /**
     * @param DateTime $date
     * @param int $dayOffset
     * @param string $dateFormat
     * @return DateTime
     */
    public static function offsetDate($date, $dayOffset = 0)
    {
        if ($dayOffset !== 0) {
            $dayOffset = intval($dayOffset);
            $modifyExpr = ($dayOffset < 0 ? $dayOffset : '+' . $dayOffset) . ' day';
            $date->modify($modifyExpr);
        }

        return $date;
    }
} 