SELECT
  CASE WHEN gr."Value" IS NULL
    THEN cr."CompanyName"
  ELSE gr."Value" END                                AS "ReportGroup",
  cr."CompanyName"                                   AS "CRName",
  CASE WHEN be."Value" IS NOT NULL
    THEN be."Value"
  ELSE v."CompanyName" END                           AS "CRVendor",
  aan."Value"                                        AS "CRAAN",
  CASE WHEN cr."AdminEmail" = cr."BillEmail"
    THEN cr."AdminEmail"
  ELSE cr."AdminEmail" || ', ' || cr."BillEmail" END AS "CREmail",
  br."resourceID"                                    AS "ResourceID",
  br."resourceName"                                  AS "ResourceName",
  br."ResourceSKU"                                   AS "ResourceSKU",
  br."CurrencyID"                                    AS "SPCurrency",
  SUM(br."ExtendedPrice")                            AS "Overall"
FROM
  "AcronisServiceProviderBreakdown" AS br
  JOIN "Account" AS cr ON cr."AccountID" = br."VendorAccountID"
  JOIN "AccAttr" AS aan ON aan."ObjID" = br."VendorAccountID" AND aan."ATID" = 'AAN'
  JOIN "Account" AS v ON v."AccountID" = cr."VendorAccountID"
  LEFT JOIN "AccAttr" AS be ON be."ObjID" = cr."AccountID" AND be."ATID" = 'BillingEntity'
  LEFT JOIN "AccAttr" AS gr ON gr."ObjID" = br."VendorAccountID" AND gr."ATID" = 'ReportGroup'
WHERE
  br."ResourceSKU" IS NOT NULL
GROUP BY
  "ReportGroup",
  "CRName",
  "CRVendor",
  "CRAAN",
  "CREmail",
  "ResourceID",
  "ResourceName",
  "ResourceSKU",
  "SPCurrency"
ORDER BY
  "CRName",
  "CRVendor",
  "SPCurrency",
  "ResourceSKU",
  "CRAAN",
  "CREmail",
  "ResourceID",
  "Overall";
