#!/usr/bin/env bash

echo '***********************************'
echo '* START REPORT GENERATION         *'
echo '***********************************'

pushd `dirname $0` > /dev/null

pwd -P

echo '***********************************'
echo '* REPORT FIX                      *'
echo '***********************************'

DATE=`date +%Y%m%d%H%M%S`

LOG_PATH="report/log/$DATE"

mkdir -p "$LOG_PATH"

bash -x report/update_orders.sh > "$LOG_PATH/update_orders.log"

echo '***********************************'
echo '* PLACE BILLING ORDERS            *'
echo '***********************************'
sudo -H -u apache bash -c 'php place_billing_orders.php -a 126 -r 1000232 -r 1000235 -r 1000238 -r 1000241 -r 1000244 -r 1000247 -r 1000250 -m LAST -d CH' |tee "$LOG_PATH/place_billing_orders_BO.log"
cat "$LOG_PATH/place_billing_orders_BO.log" | grep ERROR > "$LOG_PATH/place_billing_orders_BO_ERROR.log"

echo '***********************************'
echo '* BUILD BILLING REPORT            *'
echo '***********************************'

sudo -H -u apache bash -c 'php build_billing_report.php' |tee "$LOG_PATH/build_billing_report.log"
cat "$LOG_PATH/build_billing_report.log" |grep  ERROR > "$LOG_PATH/build_billing_report_error.log"

echo '***********************************'
echo '* PLACE CHANGE ORDERS             *'
echo '***********************************'
sudo -H -u apache bash -c 'php place_billing_orders.php -a 126 -r 1000232 -r 1000235 -r 1000238 -r 1000241 -r 1000244 -r 1000247 -r 1000250 -m LAST -d BO' |tee "$LOG_PATH/place_billing_orders_CH.log"
cat "$LOG_PATH/place_billing_orders_CH.log" |grep ERROR > "$LOG_PATH/place_billing_orders_CH_ERROR.log"

echo '***********************************'
echo '* NEW CHANGE ORDERS               *'
echo '***********************************'

grep 'Placing the order for re-assigning account' "$LOG_PATH/place_billing_orders_CH.log" |tee "$LOG_PATH/accounts_to_switch.log"

popd > /dev/null

echo '***********************************'
echo '* FINISH REPORT GENERATION        *'
echo '***********************************'
