begin;

update "OrdDet" o set "ServQty" = t."NewQty"
from (select sp."subscriptionID", sp."resourceID", sp."Amount", od."OrderID", od."ServQty",
 case when od."ServQty" < sp."Amount" then '0.00' else od."ServQty" - sp."Amount" end "NewQty"
from "SubscrParam" sp, "OrdDet" od
where sp."resourceID" IN ('1000238', '1000241', '1000244', '1000232', '1000235', '1000247', '1000250')
and sp."Amount" > 0.00
and sp."subscriptionID" = od."subscriptionID" and sp."resourceID" = od."resourceID"
and od."OrderID" IN (SELECT "OrderID" FROM "SalesOrder"  WHERE "OrderTypeID" = 'BO' AND "OrderDate" =  extract(epoch from date_trunc('month', now())) AND
                         "Customer_AccountID" IN
                         (SELECT "AccountID" FROM "Subscription" WHERE "Status" in (30, 15, 50) AND "serviceTemplateID" IN (11, 20, 14, 27)))) as t
where o."resourceID" = t."resourceID" and o."OrderID" = t."OrderID" and o."subscriptionID" = t."subscriptionID";

commit;