<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

ini_set('memory_limit', -1);
if (!ini_get('date.timezone')) {
    $timezone = exec("date +%Z");
    date_default_timezone_set(timezone_name_from_abbr($timezone));
}

$tiers = json_decode(file_get_contents('tmp/tiers.json'));

/*
SELECT
  a."AccountID",
  a."AccCurrencyCurrencyID",
  aa."Value"
FROM
  "Subscription" s, "Account" a, "AccAttr" aa
WHERE
  s."Status" = 30 AND
  s."serviceTemplateID" IN (11, 20, 14, 27) AND
  s."AccountID" = a."AccountID" AND
  a."AccountID" = aa."ObjID" AND
  aa."ATID" = 'MinComTier';
 */
if (($handle = fopen("tmp/mincomtiers.csv", "r")) !== FALSE) {
    while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
        $accountId = $data[0];
        $currencyId = $data[1];
        $resourceId = $data[2];

        $tier = array_filter($tiers, function($tier) use ($resourceId){
            return $tier->resourceTypeId == $resourceId;
        });
        $tier = $tier ?: array();
        $tier = reset($tier);
        if (!$tier) {
            echo "-- ERROR account $accountId has unknown resource $resourceId\n";
            continue;
        }

        if ($tier->level == -1) {
            echo "-- NO_MIN_COM account $accountId has no min com $resourceId\n";
            echo sprintf('update "AccAttr" set "Value" = \'%s\' where "ObjID" = \'%s\' and "ATID" = \'MinCom\';',
                    0,
                    $accountId
                ) . "\n";
            continue;
        }

        if ($tier->level == -2) {
            echo "-- CUSTOM account $accountId has custom min com $resourceId\n";
            continue;
        }

        $minCom = array_filter($tier->minimalCommitments, function($minCom) use ($currencyId) {
            return $minCom->currency == $currencyId;
        });
        $minCom = $minCom ?: array();
        $minCom = reset($minCom);
        if (!$minCom) {
            echo "-- ERROR account $accountId resource $resourceId no min com value for currency $currencyId\n";
            continue;
        }
        $minComValue = $minCom->value;

        echo sprintf('update "AccAttr" set "Value" = \'%s\' where "ObjID" = \'%s\' and "ATID" = \'MinCom\';',
            $minComValue,
            $accountId
        ) . "\n";
    }
    fclose($handle);
}










