#!/usr/bin/env bash

# sudo -upostgres psql
# drop database pba;
# create database pba with owner pba;
# ALTER DATABASE pba SET timezone TO 'Europe/Tallinn';
# \q
# sudo -upostgres psql pba < pba_dbBackup2017022007

echo 'START'

pushd `dirname $0` > /dev/null

pwd -P

mkdir -p tmp

echo '================================================================================='
echo 'Fetch tenants'
curl -k -E /var/www/html/backupservice/config/e6f5afa4-fe11-4fde-8b71-e51ce376be67.pem 'https://10.253.20.1:6308/aps/2/resources?implementing(http://acronis.com/aps/cloud-backup-v1/tenant/9.0),limit(0,10000)' > tmp/tenants.json

echo '================================================================================='
echo 'Fetch tiers'
curl -k -E /var/www/html/backupservice/config/e6f5afa4-fe11-4fde-8b71-e51ce376be67.pem 'https://10.253.20.1:6308/aps/2/resources?implementing(http://acronis.com/aps/cloud-backup-v1/minimal-commitment-tier/4.0)' > tmp/tiers.json

echo '================================================================================='
echo 'Fetch datacenters'
curl -k -E /var/www/html/backupservice/config/e6f5afa4-fe11-4fde-8b71-e51ce376be67.pem 'https://10.253.20.1:6308/aps/2/resources?implementing(http://acronis.com/aps/cloud-backup-v1/datacenter/4.0)' > tmp/datacenters.json

echo '================================================================================='
echo 'Select all minimal commitment tiers to update MinCom'
cat mincomtiers.sql
psql -h'10.253.20.5' -Upba pba < mincomtiers.sql > tmp/mincomtiers.csv

echo '================================================================================='
echo 'Generate SQL to update MinCom attributes'
echo 'begin;' > tmp/update_mincom.sql
php update_mincom.php >> tmp/update_mincom.sql
echo 'commit;' >> tmp/update_mincom.sql

echo '================================================================================='
echo 'Update MinCom attributes for accounts'
psql -h'10.253.20.5' -a -Upba pba < tmp/update_mincom.sql

echo '================================================================================='
echo 'Select orders to update usage'
cat orders.sql
psql -h'10.253.20.5' -Upba pba < orders.sql > tmp/orders.csv

echo '================================================================================='
echo 'Generate SQL to update usage in orders'
echo 'begin;' > tmp/update_usage.sql
php update_usage.php >> tmp/update_usage.sql
echo 'commit;' >> tmp/update_usage.sql

echo '================================================================================='
echo 'Update usage for orders'
psql -h'10.253.20.5' -a -Upba pba < tmp/update_usage.sql

echo '================================================================================='
echo 'Update included resources'
psql -h'10.253.20.5' -a -Upba pba < update_included_resources.sql

echo '================================================================================='

popd > /dev/null

echo 'FINISH'