# Swagger\Client\AdApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAd**](AdApi.md#getAd) | **GET** /ad | Ad
[**putAdSearch**](AdApi.md#putAdSearch) | **PUT** /ad/search | AdSearch


# **getAd**
> \Swagger\Client\Model\Ad\Details getAd($_issues)

Ad

Get AD details

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\AdApi();
$_issues = "_issues_example"; // string | 

try {
    $result = $api_instance->getAd($_issues);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AdApi->getAd: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_issues** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Ad\Details**](../Model/Ad/Details.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putAdSearch**
> \Swagger\Client\Model\Ad\Search putAdSearch($query, $context, $_issues)

AdSearch

Ad search

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\AdApi();
$query = "query_example"; // string | Search string
$context = "context_example"; // string | Search context (either domain or local machine name)
$_issues = "_issues_example"; // string | 

try {
    $result = $api_instance->putAdSearch($query, $context, $_issues);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AdApi->putAdSearch: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **query** | **string**| Search string |
 **context** | **string**| Search context (either domain or local machine name) | [optional]
 **_issues** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Ad\Search**](../Model/Ad/Search.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

