# Swagger\Client\BillingApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getBillingTenantsByTenantId**](BillingApi.md#getBillingTenantsByTenantId) | **GET** /billing/tenants/{tenant_id} | BillingTenantsByTenantId
[**getBillingTenantsPeriodsByTenantId**](BillingApi.md#getBillingTenantsPeriodsByTenantId) | **GET** /billing/tenants/{tenant_id}/periods | BillingTenantsPeriodsByTenantId
[**putBillingTenantsByTenantId**](BillingApi.md#putBillingTenantsByTenantId) | **PUT** /billing/tenants/{tenant_id} | BillingTenantsByTenantId
[**putBillingTenantsPeriodsByTenantId**](BillingApi.md#putBillingTenantsPeriodsByTenantId) | **PUT** /billing/tenants/{tenant_id}/periods | BillingTenantsPeriodsByTenantId


# **getBillingTenantsByTenantId**
> \Swagger\Client\Model\Billing\BillingTenantSettings getBillingTenantsByTenantId($tenant_id, $if_modified_since)

BillingTenantsByTenantId

Get tenant-level billing settings.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\BillingApi();
$tenant_id = "tenant_id_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getBillingTenantsByTenantId($tenant_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BillingApi->getBillingTenantsByTenantId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenant_id** | **string**|  |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Billing\BillingTenantSettings**](../Model/Billing/BillingTenantSettings.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getBillingTenantsPeriodsByTenantId**
> \Swagger\Client\Model\Billing\BillingPeriods getBillingTenantsPeriodsByTenantId($tenant_id)

BillingTenantsPeriodsByTenantId

Get custom billing periods

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\BillingApi();
$tenant_id = "tenant_id_example"; // string | 

try {
    $result = $api_instance->getBillingTenantsPeriodsByTenantId($tenant_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BillingApi->getBillingTenantsPeriodsByTenantId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenant_id** | **string**|  |

### Return type

[**\Swagger\Client\Model\Billing\BillingPeriods**](../Model/Billing/BillingPeriods.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putBillingTenantsByTenantId**
> \Swagger\Client\Model\Billing\BillingTenantSettings putBillingTenantsByTenantId($tenant_id, $body)

BillingTenantsByTenantId

Update tenant-level billing settings.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\BillingApi();
$tenant_id = "tenant_id_example"; // string | 
$body = new \Swagger\Client\Model\Billing\BillingTenantSettingsPut(); // \Swagger\Client\Model\Billing\BillingTenantSettingsPut | 

try {
    $result = $api_instance->putBillingTenantsByTenantId($tenant_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BillingApi->putBillingTenantsByTenantId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenant_id** | **string**|  |
 **body** | [**\Swagger\Client\Model\Billing\BillingTenantSettingsPut**](../Model/Billing/BillingTenantSettingsPut.md)|  |

### Return type

[**\Swagger\Client\Model\Billing\BillingTenantSettings**](../Model/Billing/BillingTenantSettings.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putBillingTenantsPeriodsByTenantId**
> \Swagger\Client\Model\Billing\BillingPeriods putBillingTenantsPeriodsByTenantId($tenant_id, $body)

BillingTenantsPeriodsByTenantId

Update custom billing periods. Do not use dates later than UTC yesterday.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\BillingApi();
$tenant_id = "tenant_id_example"; // string | 
$body = new \Swagger\Client\Model\Billing\BillingPeriodsPut(); // \Swagger\Client\Model\Billing\BillingPeriodsPut | 

try {
    $result = $api_instance->putBillingTenantsPeriodsByTenantId($tenant_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BillingApi->putBillingTenantsPeriodsByTenantId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenant_id** | **string**|  |
 **body** | [**\Swagger\Client\Model\Billing\BillingPeriodsPut**](../Model/Billing/BillingPeriodsPut.md)|  |

### Return type

[**\Swagger\Client\Model\Billing\BillingPeriods**](../Model/Billing/BillingPeriods.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

