# Swagger\Client\ClientsApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteClientsByClientId**](ClientsApi.md#deleteClientsByClientId) | **DELETE** /clients/{client_id} | ClientsByClientId
[**getClientsAccessPoliciesByClientId**](ClientsApi.md#getClientsAccessPoliciesByClientId) | **GET** /clients/{client_id}/access_policies | ClientsAccessPoliciesByClientId
[**getClientsByClientId**](ClientsApi.md#getClientsByClientId) | **GET** /clients/{client_id} | ClientsByClientId
[**postClients**](ClientsApi.md#postClients) | **POST** /clients | Clients
[**postClientsAccessPoliciesByClientId**](ClientsApi.md#postClientsAccessPoliciesByClientId) | **POST** /clients/{client_id}/access_policies | ClientsAccessPoliciesByClientId
[**putClientsByClientId**](ClientsApi.md#putClientsByClientId) | **PUT** /clients/{client_id} | ClientsByClientId


# **deleteClientsByClientId**
> deleteClientsByClientId($client_id, $version, $_issues)

ClientsByClientId

Delete a client by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ClientsApi();
$client_id = "client_id_example"; // string | 
$version = "version_example"; // string | 
$_issues = "_issues_example"; // string | 

try {
    $api_instance->deleteClientsByClientId($client_id, $version, $_issues);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->deleteClientsByClientId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **client_id** | **string**|  |
 **version** | **string**|  |
 **_issues** | **string**|  | [optional]

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getClientsAccessPoliciesByClientId**
> \Swagger\Client\Model\AccessPolicies\AccessPoliciesList getClientsAccessPoliciesByClientId($client_id, $_issues, $if_modified_since)

ClientsAccessPoliciesByClientId

List access policies.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ClientsApi();
$client_id = "client_id_example"; // string | 
$_issues = "_issues_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getClientsAccessPoliciesByClientId($client_id, $_issues, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->getClientsAccessPoliciesByClientId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **client_id** | **string**|  |
 **_issues** | **string**|  | [optional]
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\AccessPolicies\AccessPoliciesList**](../Model/AccessPolicies/AccessPoliciesList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getClientsByClientId**
> \Swagger\Client\Model\Clients\Client getClientsByClientId($client_id, $_issues, $if_modified_since)

ClientsByClientId

Get client by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ClientsApi();
$client_id = "client_id_example"; // string | 
$_issues = "_issues_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getClientsByClientId($client_id, $_issues, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->getClientsByClientId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **client_id** | **string**|  |
 **_issues** | **string**|  | [optional]
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Clients\Client**](../Model/Clients/Client.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postClients**
> \Swagger\Client\Model\Clients\Client postClients($body, $_issues)

Clients

Create a new client

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ClientsApi();
$body = new \Swagger\Client\Model\Clients\ClientPost(); // \Swagger\Client\Model\Clients\ClientPost | 
$_issues = "_issues_example"; // string | 

try {
    $result = $api_instance->postClients($body, $_issues);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->postClients: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\Clients\ClientPost**](../Model/Clients/ClientPost.md)|  |
 **_issues** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Clients\Client**](../Model/Clients/Client.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postClientsAccessPoliciesByClientId**
> \Swagger\Client\Model\AccessPolicies\AccessPolicy postClientsAccessPoliciesByClientId($client_id, $body, $_issues)

ClientsAccessPoliciesByClientId

Create a new access policy

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ClientsApi();
$client_id = "client_id_example"; // string | 
$body = new \Swagger\Client\Model\AccessPolicies\AccessPolicyPost(); // \Swagger\Client\Model\AccessPolicies\AccessPolicyPost | 
$_issues = "_issues_example"; // string | 

try {
    $result = $api_instance->postClientsAccessPoliciesByClientId($client_id, $body, $_issues);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->postClientsAccessPoliciesByClientId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **client_id** | **string**|  |
 **body** | [**\Swagger\Client\Model\AccessPolicies\AccessPolicyPost**](../Model/AccessPolicies/AccessPolicyPost.md)|  |
 **_issues** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\AccessPolicies\AccessPolicy**](../Model/AccessPolicies/AccessPolicy.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putClientsByClientId**
> \Swagger\Client\Model\Clients\Client putClientsByClientId($client_id, $body, $_issues)

ClientsByClientId

Update a client by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ClientsApi();
$client_id = "client_id_example"; // string | 
$body = new \Swagger\Client\Model\Clients\ClientPut(); // \Swagger\Client\Model\Clients\ClientPut | 
$_issues = "_issues_example"; // string | 

try {
    $result = $api_instance->putClientsByClientId($client_id, $body, $_issues);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ClientsApi->putClientsByClientId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **client_id** | **string**|  |
 **body** | [**\Swagger\Client\Model\Clients\ClientPut**](../Model/Clients/ClientPut.md)|  |
 **_issues** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Clients\Client**](../Model/Clients/Client.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

