# Swagger\Client\IdentityApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteIdentityProvidersByIdpId**](IdentityApi.md#deleteIdentityProvidersByIdpId) | **DELETE** /identity_providers/{idp_id} | IdentityProvidersByIdpId
[**getIdentityProviders**](IdentityApi.md#getIdentityProviders) | **GET** /identity_providers | IdentityProviders
[**getIdentityProvidersByIdpId**](IdentityApi.md#getIdentityProvidersByIdpId) | **GET** /identity_providers/{idp_id} | IdentityProvidersByIdpId
[**postIdentityProviders**](IdentityApi.md#postIdentityProviders) | **POST** /identity_providers | IdentityProviders
[**putIdentityProvidersByIdpId**](IdentityApi.md#putIdentityProvidersByIdpId) | **PUT** /identity_providers/{idp_id} | IdentityProvidersByIdpId


# **deleteIdentityProvidersByIdpId**
> deleteIdentityProvidersByIdpId($idp_id, $version)

IdentityProvidersByIdpId

Unregister identity provider by ID

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdentityApi();
$idp_id = "idp_id_example"; // string | 
$version = 56; // int | 

try {
    $api_instance->deleteIdentityProvidersByIdpId($idp_id, $version);
} catch (Exception $e) {
    echo 'Exception when calling IdentityApi->deleteIdentityProvidersByIdpId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **idp_id** | **string**|  |
 **version** | **int**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getIdentityProviders**
> \Swagger\Client\Model\IdentityProviders\IdpBatch getIdentityProviders($uuids, $if_modified_since)

IdentityProviders

Batch get of identity providers

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdentityApi();
$uuids = "uuids_example"; // string | Comma separated UUIDs of identity providers
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getIdentityProviders($uuids, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdentityApi->getIdentityProviders: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **uuids** | **string**| Comma separated UUIDs of identity providers |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\IdentityProviders\IdpBatch**](../Model/IdentityProviders/IdpBatch.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getIdentityProvidersByIdpId**
> \Swagger\Client\Model\IdentityProviders\Idp getIdentityProvidersByIdpId($idp_id, $if_modified_since)

IdentityProvidersByIdpId

Get identity provider by ID

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdentityApi();
$idp_id = "idp_id_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getIdentityProvidersByIdpId($idp_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdentityApi->getIdentityProvidersByIdpId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **idp_id** | **string**|  |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\IdentityProviders\Idp**](../Model/IdentityProviders/Idp.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postIdentityProviders**
> \Swagger\Client\Model\IdentityProviders\Idp postIdentityProviders($body)

IdentityProviders

Register new identity provider

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdentityApi();
$body = new \Swagger\Client\Model\IdentityProviders\IdpPost(); // \Swagger\Client\Model\IdentityProviders\IdpPost | 

try {
    $result = $api_instance->postIdentityProviders($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdentityApi->postIdentityProviders: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\IdentityProviders\IdpPost**](../Model/IdentityProviders/IdpPost.md)|  |

### Return type

[**\Swagger\Client\Model\IdentityProviders\Idp**](../Model/IdentityProviders/Idp.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putIdentityProvidersByIdpId**
> \Swagger\Client\Model\IdentityProviders\Idp putIdentityProvidersByIdpId($idp_id, $body)

IdentityProvidersByIdpId

Update identity provider by ID

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdentityApi();
$idp_id = "idp_id_example"; // string | 
$body = new \Swagger\Client\Model\IdentityProviders\IdpPut(); // \Swagger\Client\Model\IdentityProviders\IdpPut | 

try {
    $result = $api_instance->putIdentityProvidersByIdpId($idp_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdentityApi->putIdentityProvidersByIdpId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **idp_id** | **string**|  |
 **body** | [**\Swagger\Client\Model\IdentityProviders\IdpPut**](../Model/IdentityProviders/IdpPut.md)|  |

### Return type

[**\Swagger\Client\Model\IdentityProviders\Idp**](../Model/IdentityProviders/Idp.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

