# Swagger\Client\InfraApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteInfraByInfraId**](InfraApi.md#deleteInfraByInfraId) | **DELETE** /infra/{infra_id} | InfraByInfraId
[**getInfra**](InfraApi.md#getInfra) | **GET** /infra | Infra
[**getInfraByInfraId**](InfraApi.md#getInfraByInfraId) | **GET** /infra/{infra_id} | InfraByInfraId
[**postInfra**](InfraApi.md#postInfra) | **POST** /infra | Infra
[**putInfraByInfraId**](InfraApi.md#putInfraByInfraId) | **PUT** /infra/{infra_id} | InfraByInfraId


# **deleteInfraByInfraId**
> deleteInfraByInfraId($infra_id, $version, $force)

InfraByInfraId

Unregister infrastructure component by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\InfraApi();
$infra_id = "infra_id_example"; // string | 
$version = 56; // int | Growing number of infrastructure component's version
$force = true; // bool | When force=true is passed delete will ignore existing usage if there are no customers having offering items associated with this infra component turned on

try {
    $api_instance->deleteInfraByInfraId($infra_id, $version, $force);
} catch (Exception $e) {
    echo 'Exception when calling InfraApi->deleteInfraByInfraId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **infra_id** | **string**|  |
 **version** | **int**| Growing number of infrastructure component&#39;s version |
 **force** | **bool**| When force&#x3D;true is passed delete will ignore existing usage if there are no customers having offering items associated with this infra component turned on | [optional]

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getInfra**
> \Swagger\Client\Model\Infra\InfraBatch getInfra($uuids, $if_modified_since)

Infra

Batch get of infrastructure components

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\InfraApi();
$uuids = "uuids_example"; // string | Comma separated UUIDs of infrastructure components
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getInfra($uuids, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling InfraApi->getInfra: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **uuids** | **string**| Comma separated UUIDs of infrastructure components |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Infra\InfraBatch**](../Model/Infra/InfraBatch.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getInfraByInfraId**
> \Swagger\Client\Model\Infra\Infra getInfraByInfraId($infra_id, $if_modified_since)

InfraByInfraId

Get infrastructure component by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\InfraApi();
$infra_id = "infra_id_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getInfraByInfraId($infra_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling InfraApi->getInfraByInfraId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **infra_id** | **string**|  |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Infra\Infra**](../Model/Infra/Infra.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postInfra**
> \Swagger\Client\Model\Infra\Infra postInfra($body)

Infra

Register new infrastructure component

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\InfraApi();
$body = new \Swagger\Client\Model\Infra\InfraPost(); // \Swagger\Client\Model\Infra\InfraPost | 

try {
    $result = $api_instance->postInfra($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling InfraApi->postInfra: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\Infra\InfraPost**](../Model/Infra/InfraPost.md)|  |

### Return type

[**\Swagger\Client\Model\Infra\Infra**](../Model/Infra/Infra.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putInfraByInfraId**
> \Swagger\Client\Model\Infra\Infra putInfraByInfraId($infra_id, $body)

InfraByInfraId

Update infrastructure component by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\InfraApi();
$infra_id = "infra_id_example"; // string | 
$body = new \Swagger\Client\Model\Infra\InfraPut(); // \Swagger\Client\Model\Infra\InfraPut | 

try {
    $result = $api_instance->putInfraByInfraId($infra_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling InfraApi->putInfraByInfraId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **infra_id** | **string**|  |
 **body** | [**\Swagger\Client\Model\Infra\InfraPut**](../Model/Infra/InfraPut.md)|  |

### Return type

[**\Swagger\Client\Model\Infra\Infra**](../Model/Infra/Infra.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

