# Swagger\Client\UserApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteUserGroupsByUserGroupId**](UserApi.md#deleteUserGroupsByUserGroupId) | **DELETE** /user_groups/{user_group_id} | UserGroupsByUserGroupId
[**getUserGroupsAccessPolicies**](UserApi.md#getUserGroupsAccessPolicies) | **GET** /user_groups/access_policies | UserGroupsAccessPolicies
[**getUserGroupsAccessPoliciesByUserGroupId**](UserApi.md#getUserGroupsAccessPoliciesByUserGroupId) | **GET** /user_groups/{user_group_id}/access_policies | UserGroupsAccessPoliciesByUserGroupId
[**getUserGroupsByUserGroupId**](UserApi.md#getUserGroupsByUserGroupId) | **GET** /user_groups/{user_group_id} | UserGroupsByUserGroupId
[**postUserGroups**](UserApi.md#postUserGroups) | **POST** /user_groups | UserGroups
[**postUserGroupsAccessPolicies**](UserApi.md#postUserGroupsAccessPolicies) | **POST** /user_groups/access_policies | UserGroupsAccessPolicies
[**postUserGroupsAccessPoliciesByUserGroupId**](UserApi.md#postUserGroupsAccessPoliciesByUserGroupId) | **POST** /user_groups/{user_group_id}/access_policies | UserGroupsAccessPoliciesByUserGroupId
[**postUserGroupsChangeEmail**](UserApi.md#postUserGroupsChangeEmail) | **POST** /user_groups/change_email | UserGroupsChangeEmail
[**putUserGroupsAccessPolicies**](UserApi.md#putUserGroupsAccessPolicies) | **PUT** /user_groups/access_policies | UserGroupsAccessPolicies


# **deleteUserGroupsByUserGroupId**
> deleteUserGroupsByUserGroupId($user_group_id, $version)

UserGroupsByUserGroupId

Delete a user group by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\UserApi();
$user_group_id = "user_group_id_example"; // string | 
$version = "version_example"; // string | 

try {
    $api_instance->deleteUserGroupsByUserGroupId($user_group_id, $version);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->deleteUserGroupsByUserGroupId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_group_id** | **string**|  |
 **version** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUserGroupsAccessPolicies**
> \Swagger\Client\Model\AccessPolicies\AccessPoliciesList getUserGroupsAccessPolicies($if_modified_since)

UserGroupsAccessPolicies

List user's access policies

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\UserApi();
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getUserGroupsAccessPolicies($if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->getUserGroupsAccessPolicies: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\AccessPolicies\AccessPoliciesList**](../Model/AccessPolicies/AccessPoliciesList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUserGroupsAccessPoliciesByUserGroupId**
> string getUserGroupsAccessPoliciesByUserGroupId($user_group_id, $_issues)

UserGroupsAccessPoliciesByUserGroupId

Get access policies

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\UserApi();
$user_group_id = "user_group_id_example"; // string | 
$_issues = "_issues_example"; // string | 

try {
    $result = $api_instance->getUserGroupsAccessPoliciesByUserGroupId($user_group_id, $_issues);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->getUserGroupsAccessPoliciesByUserGroupId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_group_id** | **string**|  |
 **_issues** | **string**|  | [optional]

### Return type

**string**

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUserGroupsByUserGroupId**
> string getUserGroupsByUserGroupId($user_group_id, $_issues)

UserGroupsByUserGroupId

Get user group by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\UserApi();
$user_group_id = "user_group_id_example"; // string | 
$_issues = "_issues_example"; // string | 

try {
    $result = $api_instance->getUserGroupsByUserGroupId($user_group_id, $_issues);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->getUserGroupsByUserGroupId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_group_id** | **string**|  |
 **_issues** | **string**|  | [optional]

### Return type

**string**

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postUserGroups**
> \Swagger\Client\Model\UserGroups\UserGroup postUserGroups($body)

UserGroups

Create a new user group

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\UserApi();
$body = new \Swagger\Client\Model\UserGroups\UserGroupPost(); // \Swagger\Client\Model\UserGroups\UserGroupPost | 

try {
    $result = $api_instance->postUserGroups($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->postUserGroups: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\UserGroups\UserGroupPost**](../Model/UserGroups/UserGroupPost.md)|  |

### Return type

[**\Swagger\Client\Model\UserGroups\UserGroup**](../Model/UserGroups/UserGroup.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postUserGroupsAccessPolicies**
> \Swagger\Client\Model\AccessPolicies\AccessPolicy postUserGroupsAccessPolicies($body)

UserGroupsAccessPolicies

Create a new access policy

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\UserApi();
$body = new \Swagger\Client\Model\AccessPolicies\AccessPolicyPost(); // \Swagger\Client\Model\AccessPolicies\AccessPolicyPost | 

try {
    $result = $api_instance->postUserGroupsAccessPolicies($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->postUserGroupsAccessPolicies: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\AccessPolicies\AccessPolicyPost**](../Model/AccessPolicies/AccessPolicyPost.md)|  |

### Return type

[**\Swagger\Client\Model\AccessPolicies\AccessPolicy**](../Model/AccessPolicies/AccessPolicy.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postUserGroupsAccessPoliciesByUserGroupId**
> string postUserGroupsAccessPoliciesByUserGroupId($user_group_id, $_issues)

UserGroupsAccessPoliciesByUserGroupId

Add access policies

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\UserApi();
$user_group_id = "user_group_id_example"; // string | 
$_issues = "_issues_example"; // string | 

try {
    $result = $api_instance->postUserGroupsAccessPoliciesByUserGroupId($user_group_id, $_issues);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->postUserGroupsAccessPoliciesByUserGroupId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_group_id** | **string**|  |
 **_issues** | **string**|  | [optional]

### Return type

**string**

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postUserGroupsChangeEmail**
> postUserGroupsChangeEmail($body)

UserGroupsChangeEmail

Send a letter with a change email link

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\UserApi();
$body = new \Swagger\Client\Model\Users\UserChangeEmailPost(); // \Swagger\Client\Model\Users\UserChangeEmailPost | 

try {
    $api_instance->postUserGroupsChangeEmail($body);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->postUserGroupsChangeEmail: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\Users\UserChangeEmailPost**](../Model/Users/UserChangeEmailPost.md)|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putUserGroupsAccessPolicies**
> \Swagger\Client\Model\AccessPolicies\AccessPoliciesList putUserGroupsAccessPolicies($body)

UserGroupsAccessPolicies

Rewrite access policy to user

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\UserApi();
$body = new \Swagger\Client\Model\AccessPolicies\AccessPoliciesList(); // \Swagger\Client\Model\AccessPolicies\AccessPoliciesList | 

try {
    $result = $api_instance->putUserGroupsAccessPolicies($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->putUserGroupsAccessPolicies: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\AccessPolicies\AccessPoliciesList**](../Model/AccessPolicies/AccessPoliciesList.md)|  |

### Return type

[**\Swagger\Client\Model\AccessPolicies\AccessPoliciesList**](../Model/AccessPolicies/AccessPoliciesList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

