<?php
/**
 * Setting
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * REST API v2 description for Multi-service Portal
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model\Settings;

use Swagger\Client\BaseModel;
/**
 * Setting Class Doc Comment
 *
 * @category    Class
 * @package     Swagger\Client
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class Setting extends BaseModel 
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'Settings\Setting';

    /**
     * Array of property to type mappings. Used for (de)serialization
     * @return array
     */
    public static function swaggerTypes()
    {
        return [
            'name' => 'string',
            'application_id' => 'string',
            'own' => '\Swagger\Client\Model\Settings\SettingOwn',
            'effective' => '\Swagger\Client\Model\Settings\SettingEffective'
        ];
    }


    /**
     * Array of property to format mappings. Used for (de)serialization
     * @return array
     */
    public static function swaggerFormats()
    {
        return [
            'name' => null,
            'application_id' => null,
            'own' => null,
            'effective' => null
        ];
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @return array
     */
    public static function attributeMap()
    {
        return [
            'name' => 'name',
            'application_id' => 'application_id',
            'own' => 'own',
            'effective' => 'effective'
        ];
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @return array
     */
    public static function setters()
    {
        return [
            'name' => 'setName',
            'application_id' => 'setApplicationId',
            'own' => 'setOwn',
            'effective' => 'setEffective'
        ];
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @return array
     */
    public static function getters()
    {
        return [
            'name' => 'getName',
            'application_id' => 'getApplicationId',
            'own' => 'getOwn',
            'effective' => 'getEffective'
        ];
    }

    /**
     * Array of attributes to checkers functions (for deserialization of responses)
     * @return array
     */
    public static function checkers()
    {
        return [
            'name' => 'hasName',
            'application_id' => 'hasApplicationId',
            'own' => 'hasOwn',
            'effective' => 'hasEffective'
        ];
    }

    /**
     * Array of attributes to validators functions (for deserialization of responses)
     * @return array
     */
    public static function validators() {
        return [
            'name' => 'validateName',
            'application_id' => 'validateApplicationId',
            'own' => 'validateOwn',
            'effective' => 'validateEffective'
        ];
    }

    

    

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        if (!empty($this->validateName())) {
            $invalid_properties[] = $this->validateName();
        }
        if (!empty($this->validateApplicationId())) {
            $invalid_properties[] = $this->validateApplicationId();
        }
        if (!empty($this->validateOwn())) {
            $invalid_properties[] = $this->validateOwn();
        }
        if (!empty($this->validateEffective())) {
            $invalid_properties[] = $this->validateEffective();
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        if (!empty($this->validateName())) {
            return false;
        }
        if (!empty($this->validateApplicationId())) {
            return false;
        }
        if (!empty($this->validateOwn())) {
            return false;
        }
        if (!empty($this->validateEffective())) {
            return false;
        }
        return true;
    }


    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->offsetGet('name');
    }

    /**
     * Checks name
     * @return boolean
     */
    public function hasName()
    {
        return $this->offsetExists('name');
    }

    /**
     * Sets name
     * @param string $name Name of the setting, for internal use by the platform and applications. Serves as the setting's ID
     * @return $this
     */
    public function setName($name)
    {
        $this->offsetSet('name', $name);

        return $this;
    }

    /**
     * Unset name
     */
    public function unsetName() {
        $this->offsetUnset('name');
    }

    /**
     * Valid name
     * @return array|boolean
     */
    public function validateName()
    {
        if (!$this->offsetExists('name')) {
            return "Property 'name' was not initialized.";
        }
        return false;
    }


    /**
     * Gets application_id
     * @return string
     */
    public function getApplicationId()
    {
        return $this->offsetGet('application_id');
    }

    /**
     * Checks application_id
     * @return boolean
     */
    public function hasApplicationId()
    {
        return $this->offsetExists('application_id');
    }

    /**
     * Sets application_id
     * @param string $application_id ID of application that this setting belongs to
     * @return $this
     */
    public function setApplicationId($application_id)
    {
        if (!is_null($application_id) && (strlen($application_id) > 36)) {
            throw new \InvalidArgumentException('invalid length for $application_id when calling Setting., must be smaller than or equal to 36.');
        }
        if (!is_null($application_id) && (strlen($application_id) < 36)) {
            throw new \InvalidArgumentException('invalid length for $application_id when calling Setting., must be bigger than or equal to 36.');
        }
        if (!is_null($application_id) && (!preg_match("/[0-9a-f]{8}-([0-9a-f]{4}-){3}[0-9a-f]{12}/", $application_id))) {
            throw new \InvalidArgumentException("invalid value for $application_id when calling Setting., must conform to the pattern /[0-9a-f]{8}-([0-9a-f]{4}-){3}[0-9a-f]{12}/.");
        }

        $this->offsetSet('application_id', $application_id);

        return $this;
    }

    /**
     * Unset application_id
     */
    public function unsetApplicationId() {
        $this->offsetUnset('application_id');
    }

    /**
     * Valid application_id
     * @return array|boolean
     */
    public function validateApplicationId()
    {
        if (!$this->offsetExists('application_id')) {
            return false;
        }
            if ($this->offsetExists('application_id') && strlen($this->offsetGet('application_id')) > 36) {
                return "invalid value for 'application_id', the character length must be smaller than or equal to 36.";
            }
            if ($this->offsetExists('application_id') && strlen($this->offsetGet('application_id')) < 36) {
                return "invalid value for 'application_id', the character length must be bigger than or equal to 36.";
            }
            if ($this->offsetExists('application_id') && !preg_match("/[0-9a-f]{8}-([0-9a-f]{4}-){3}[0-9a-f]{12}/", $this->offsetGet('application_id'))) {
                return "invalid value for 'application_id', must be conform to the pattern /[0-9a-f]{8}-([0-9a-f]{4}-){3}[0-9a-f]{12}/.";
            }
        return false;
    }


    /**
     * Gets own
     * @return \Swagger\Client\Model\Settings\SettingOwn
     */
    public function getOwn()
    {
        return $this->offsetGet('own');
    }

    /**
     * Checks own
     * @return boolean
     */
    public function hasOwn()
    {
        return $this->offsetExists('own');
    }

    /**
     * Sets own
     * @param \Swagger\Client\Model\Settings\SettingOwn $own
     * @return $this
     */
    public function setOwn($own)
    {
        $this->offsetSet('own', $own);

        return $this;
    }

    /**
     * Unset own
     */
    public function unsetOwn() {
        $this->offsetUnset('own');
    }

    /**
     * Valid own
     * @return array|boolean
     */
    public function validateOwn()
    {
        if (!$this->offsetExists('own')) {
            return false;
        }
        return false;
    }


    /**
     * Gets effective
     * @return \Swagger\Client\Model\Settings\SettingEffective
     */
    public function getEffective()
    {
        return $this->offsetGet('effective');
    }

    /**
     * Checks effective
     * @return boolean
     */
    public function hasEffective()
    {
        return $this->offsetExists('effective');
    }

    /**
     * Sets effective
     * @param \Swagger\Client\Model\Settings\SettingEffective $effective
     * @return $this
     */
    public function setEffective($effective)
    {
        $this->offsetSet('effective', $effective);

        return $this;
    }

    /**
     * Unset effective
     */
    public function unsetEffective() {
        $this->offsetUnset('effective');
    }

    /**
     * Valid effective
     * @return array|boolean
     */
    public function validateEffective()
    {
        if (!$this->offsetExists('effective')) {
            return "Property 'effective' was not initialized.";
        }
        return false;
    }

}


